package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.WebElement;
import org.openqa.selenium.interactions.Actions;
import org.openqa.selenium.support.ui.ExpectedConditions;
import org.openqa.selenium.support.ui.WebDriverWait;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmbalagemPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaEmbalagem = By.xpath("//span[text() = 'Embalagem']");

    By botaoAddRelacaoEmbalagemTransportada = By.xpath("//footer[@id=\"footer\"]//div[@class=\"zh-footer-center\"]//li[@zh-ripple-effect]");
    By botaoExcluirRelacaoEmbalagemTransportada = By.xpath("//footer[@id=\"footer\"]//div[@class=\"zh-footer-center\"]//li[@zh-ripple-effect]");
    By botaoVoltarRelacaoEmbalagemTransportada = By.xpath("//footer[@id=\"footer\"]//div[@class=\"zh-footer-left\"]//li[@zh-ripple-effect]");
    By botaoAdicionar = By.xpath("//footer[@id=\"footer\"]//li[@zh-ripple-effect]");
    By botaoUnidade = By.xpath("//div[@id=\"SGUNIDADE\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoSalvar = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-left\"]");
    By botaoCancelar = By.xpath("//div[@id=\"footer\"]//div[@class=\"zh-footer-left\"]");
    By botaoEditar = By.xpath("//div[@id=\"footer\"]//li[@data-zh-id=\"12378797142006480426654\"]");
    By botaoExcluir = By.xpath("//div[@id=\"footer\"]//li[@data-zh-id=\"1237879714379788563652\"]");
    By botaoSimDeletar = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@type=\"submit\"]");

    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");
    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input");

    By abaRelacaoEmbalagemTransportada = By.xpath("//header[@class=\"row row-fluid zh-header zh-custom-tabbed-widget\"]//a[text() = 'Relação de Embalagens Transportadas']");
    By campoCodigoRelacaoEmbTransportada = By.id("CDEMBALAGEM");
    By campoEmbalagemRelacaoEmbTransportada = By.id("NMCONTAINER");
    By campoQuantidadeRelacaoEmbTransportada = By.id("QTCAPACIDADE");
    By embSaladaRelacaoEmbTransportada = By.xpath("//div[@data-zh-id=\"12378797141870885313725\"]//span[text() = '00001 | SALADA']");
    By checkBoxRelacaoEmbTransportada = By.xpath("//div[@id=\"grid-12378797141086156804660\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoRelacaoEmbTransportada = By.xpath("//div[@id=\"grid-12378797141086156804660\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDEMBALAGEM\"]/span");
    By nomeEmbalagemRelacaoEmbTransportada = By.xpath("//div[@id=\"grid-12378797141086156804660\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMCONTAINER\"]/span");
    By quantRelacaoEmbTransportada = By.xpath("//div[@id=\"grid-12378797141086156804660\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTCAPACIDADE\"]/span");

    By checkBoxEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By codigoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDCONTAINER\"]/span");
    By nomeEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMCONTAINER\"]/span");
    By tipoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDEMBALAGEM\"]/span");
    By propositoEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"IDPROPOSITO\"]/span");
    By capacidadeEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"QTCONTAINER\"]/span");
    By categoriaEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMCATEMBALAG\"]/span");
    By unidadeEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"SGUNIDADE\"]/span");
    By taraEmbalagemLinha1 = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"VRPESOCONTAINER\"]/span");

    By campoCodigo = By.id("CDCONTAINER");
    By campoEmbalagem = By.id("NMCONTAINER");
    By listaTipo = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By campoTipo = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By campoTipoDesabilitado = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//div[@readonly=\"readonly\"]");
    By tipoAmbos = By.xpath("//div[@data-zh-id=\"1237879714945008112702\"]//li[text() = 'Ambos']");
    By listaProposito = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//ul[@class=\"list zh-new-select-list\"]/li");
    By campoProposito = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By campoPropositoDesabilitado = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//div[@readonly=\"readonly\"]");
    By propositoIndividual = By.xpath("//div[@data-zh-id=\"12378797142683876946704\"]//li[text() = 'Individual']");
    By campoCategoria = By.id("NMCATEMBALAG");
    By categoriaPrimaria = By.xpath("//div[@data-zh-id=\"12378797141471844620707\"]//span[text() = '00001 | PRIMÁRIA']");
    By categoriaSecundaria = By.xpath("//div[@data-zh-id=\"12378797141471844620707\"]//span[text() = '00002 | SECUNDÁRIA']");
    By unidadeMililitro = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'MILILITRO']");
    By unidadeLata = By.xpath("//div[@data-zh-field-name=\"DSUNIDADE\"]//span[text() = 'LATA']");
    By campoCapacidade = By.id("QTCONTAINER");
    By campoTara = By.id("VRPESOCONTAINER");

    By mensagemObrigatorioCodigo = By.xpath("//div[@data-zh-id=\"12378797142511755336700\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioEmbalagem = By.xpath("//div[@data-zh-id=\"12378797144240840199701\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioCodigoRelacaoEmb = By.xpath("//div[@data-zh-id=\"12378797142148107380726\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioEmbalagemRelacaoEmb = By.xpath("//div[@data-zh-id=\"12378797141870885313725\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioQuantRelacaoEmb = By.xpath("//div[@data-zh-id=\"12378797141559204944729\"]//div[@class=\"zh-validation\"]/span");

    By mensagemNenhumRegistroTelaInicial = By.xpath("//div[@id=\"grid-12378797141192963454630\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemNaoHaRegistroRelacaoEmbTransportada = By.xpath("//div[@id=\"grid-12378797141086156804660\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");
    By mensagemSucesso = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlertaExclusao = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Embalagem");
        click(opcaoTelaEmbalagem);
    }

    public void adicionar() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "50");
        sendKeys(campoEmbalagem, "PANELA");
        clicarCampoSelecionarValor(campoTipo, tipoAmbos);
        clicarCampoSelecionarValor(campoProposito, propositoIndividual);
        clicarCampoSelecionarValor(campoCategoria, categoriaPrimaria);
        click(botaoUnidade);
        sendKeys(campoProcurar, "MILILITRO");
        click(unidadeMililitro);
        sendKeys(campoCapacidade, "5");
        sendKeys(campoTara, "7");

        click(botaoSalvar);
        tempo();
        click(botaoVoltar);
        preencherCampoProcurarTelaInicial("00050");

        String codigo = getText(codigoEmbalagemLinha1);
        String nome = getText(nomeEmbalagemLinha1);
        String tipo = getText(tipoEmbalagemLinha1);
        String proposito = getText(propositoEmbalagemLinha1);
        String categoria = getText(categoriaEmbalagemLinha1);
        String unidade = getText(unidadeEmbalagemLinha1);
        String capacidade = getText(capacidadeEmbalagemLinha1);
        String tara = getText(taraEmbalagemLinha1);

        Assert.assertEquals(codigo, "00050", "Verificação do código");
        Assert.assertEquals(capacidade, "5,00000", "Verificação da capacidade");
        Assert.assertEquals(nome, "PANELA", "Verificação do nome");
        Assert.assertEquals(tipo, "Ambos", "Verificação do tipo");
        Assert.assertEquals(proposito, "Individual", "Verificação do propósito");
        Assert.assertEquals(categoria, "PRIMÁRIA", "Verificação da categoria");
        Assert.assertEquals(unidade, "ML", "Verificação da unidade");
        Assert.assertEquals(tara, "7,00000", "Verificação do tara");
    }

    public void excluir() {
        preencherCampoProcurarTelaInicial("00050");
        click(checkBoxEmbalagemLinha1);
        tempo();
        click(botaoExcluir);
        tempo();
        String mensagemAlerta = getText(mensagemAlertaExclusao);
        Assert.assertEquals(mensagemAlerta, "Deletar o(s) registro(s)?", "Verificação da mensagem de exclusão da embalagem");
        click(botaoSimDeletar);

        String mensagemExcluidoSucesso = getText(mensagemSucesso);
        Assert.assertEquals(mensagemExcluidoSucesso, "Excluído com sucesso.", "Verificação da mensagem de excluído om sucesso, após a exclusão da embalagem");
        String mensagemNaoHaRegistro = getText(mensagemNenhumRegistroTelaInicial);
        String mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagemNaoHaRegistro, mensagemEsperada, "Verificação da mensagem de nenhum registro encontrado após a exclusão da embalagem");
    }

    public void editarEmbalagem() {
        preencherCampoProcurarTelaInicial("00008");
        click(nomeEmbalagemLinha1);
        tempo();
        click(botaoEditar);
        clearAndSendKeys(campoEmbalagem, "MADEIRA EUCALIPTO");
        click(campoCapacidade);
        clearAndSendKeys(campoCapacidade, "9");
        click(campoTara);
        clearAndSendKeys(campoTara, "3");
        clicarCampoSelecionarValor(campoCategoria, categoriaSecundaria);
        click(botaoUnidade);
        click(botaoUnidade);
        sendKeys(campoProcurar, "LATA");
        click(unidadeLata);
        click(botaoSalvar);
        tempo();
        tempo();
        click(botaoVoltar);

        preencherCampoProcurarTelaInicial("00008");
        String nome = getText(nomeEmbalagemLinha1);
        String categoria = getText(categoriaEmbalagemLinha1);
        String capacidade = getText(capacidadeEmbalagemLinha1);
        String unidade = getText(unidadeEmbalagemLinha1);
        String tara = getText(taraEmbalagemLinha1);
        Assert.assertEquals(nome, "MADEIRA EUCALIPTO", "Verificação do nome após realizar a edição da embalagem");
        Assert.assertEquals(categoria, "SECUNDÁRIA", "Verificação da categoria após realizar a edição da embalagem");
        Assert.assertEquals(capacidade, "9,00000", "Verificação da capacidade após realizar a edição da embalagem");
        Assert.assertEquals(unidade, "LA", "Verificação da unidade após realizar a edição da embalagem");
        Assert.assertEquals(tara, "3,00000", "Verificação do tara após realizar a edição da embalagem");

        //editar os campos para os valores que estavam no início do teste da edição
        click(nomeEmbalagemLinha1);
        tempo();
        click(botaoEditar);
        clearAndSendKeys(campoEmbalagem, "PANELA");
        click(campoCapacidade);
        clearAndSendKeys(campoCapacidade, "4");
        click(campoTara);
        clearAndSendKeys(campoTara, "2");
        clicarCampoSelecionarValor(campoCategoria, categoriaPrimaria);
        click(botaoUnidade);
        click(botaoUnidade);
        sendKeys(campoProcurar, "MILILITRO");
        click(unidadeMililitro);
        click(botaoSalvar);
        tempo();
        click(botaoVoltar);

        preencherCampoProcurarTelaInicial("00008");
        nome = getText(nomeEmbalagemLinha1);
        categoria = getText(categoriaEmbalagemLinha1);
        capacidade = getText(capacidadeEmbalagemLinha1);
        unidade = getText(unidadeEmbalagemLinha1);
        tara = getText(taraEmbalagemLinha1);
        Assert.assertEquals(nome, "PANELA", "Verificação do nome após realizar a edição da embalagem, retornando para os valores iniciais antes do teste da edição");
        Assert.assertEquals(categoria, "PRIMÁRIA", "Verificação da categoria após realizar a edição da embalagem, retornando para os valores iniciais antes do teste da edição");
        Assert.assertEquals(capacidade, "4,00000", "Verificação da capacidade após realizar a edição da embalagem, retornando para os valores iniciais antes do teste da edição");
        Assert.assertEquals(unidade, "ML", "Verificação da unidade após realizar a edição da embalagem, retornando para os valores iniciais antes do teste da edição");
        Assert.assertEquals(tara, "2,00000", "Verificação do tara após realizar a edição da embalagem, retornando para os valores iniciais antes do teste da edição");
    }

    public void tentarExcluirEmbaComRegistrosFilhos() {
        preencherCampoProcurarTelaInicial("00001");
        click(checkBoxEmbalagemLinha1);
        click(botaoExcluir);
        tempo();
        String mensagemAlerta = getText(mensagemAlertaExclusao);
        Assert.assertEquals(mensagemAlerta, "Deletar o(s) registro(s)?", "Verificação da mensagem de exclusão da embalagem");
        click(botaoSimDeletar);

        mensagemAlerta = getText(mensagemAlertaExclusao);
        String mensagemEsperada = "Exclusão não permitida! O registro possui registros filhos.";
        Assert.assertEquals(mensagemAlerta, mensagemEsperada, "Verificação da mensagem de alerta informando que não é possível excluir a embalagem, pois a mesma possuí registros filhos");
        click(botaoOk);
    }

    public void tentarAddCodigoExistente() {
        tempo();
        click(botaoAdicionar);
        sendKeys(campoCodigo, "1");
        sendKeys(campoEmbalagem, "PANELA");
        clicarCampoSelecionarValor(campoTipo, tipoAmbos);
        clicarCampoSelecionarValor(campoProposito, propositoIndividual);
        click(botaoSalvar);

        //mensagem alerta de código já existente
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de alerta exibida após tentar adicionar um código já existente");
        click(botaoOk);
    }

    public void verificarListTipo() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(campoTipo);
        //lista de tipo
        List<String> tipos = new ArrayList<>();
        tipos.add("Envase");
        tipos.add("Transporte");
        tipos.add("Ambos");


        long timeout = 0;
        List<WebElement> result = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                listaTipo
                        )
                );

        for (int index = 0; index < result.size(); index ++) {
            Assert.assertEquals(result.get(index).getText(), tipos.get(index), "Verificação do item " + (index + 1) + " da lista de tipo");
        }
        click(botaoCancelar);
    }

    public void verificarListProposito() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(campoProposito);
        //lista de propósito
        List<String> propositos = new ArrayList<>();
        propositos.add("Coletivo");
        propositos.add("Individual");

        long timeout = 0;
        List<WebElement> result = (new WebDriverWait(driver, timeout))
                .until(ExpectedConditions
                        .visibilityOfAllElementsLocatedBy(
                                listaProposito
                        )
                );

        for (int index = 0; index < result.size(); index ++) {
            Assert.assertEquals(result.get(index).getText(), propositos.get(index), "Verificação do item " + (index + 1) + " da lista de propósitos");
        }
        click(botaoCancelar);
    }

    public void camposObrigatoriosAddEmbalagem() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        //mensagem de campo obrigatório encontrada nos campos
        String codigo = getText(mensagemObrigatorioCodigo);
        String embalagem = getText(mensagemObrigatorioEmbalagem);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo código");
        Assert.assertEquals(embalagem, mensagemEsperada, "Verificação da mensagem de campo obrigatório, do campo embalagem");
    }

    public void campoDesabilitadosDuranteEdicao() {
        preencherCampoProcurarTelaInicial("00008");
        click(nomeEmbalagemLinha1);
        tempo();
        click(botaoEditar);

        boolean codico = returnIfElementIsEnabled(campoCodigo);
        boolean tipo = returnIfElementExists(campoTipoDesabilitado);
        boolean proposito = returnIfElementExists(campoPropositoDesabilitado);
        Assert.assertEquals(codico, false, "Verificação se o campo código está desabilitado no processo de editar uma embalagem");
        Assert.assertEquals(tipo, true, "Verificação se o campo código está desabilitado no processo de editar uma embalagem");
        Assert.assertEquals(proposito, true, "Verificação se o campo código está desabilitado no processo de editar uma embalagem");
    }

    public void editarCapacidadeTaraPelaTelaInicial() {
        preencherCampoProcurarTelaInicial("00009");
        editarCampoTelaInicial(capacidadeEmbalagemLinha1, "8,5");
        editarCampoTelaInicial(taraEmbalagemLinha1, "2,6");
        click(botaoSalvarAlteracoes);

        preencherCampoProcurarTelaInicial("00009");
        String capacidade = getText(capacidadeEmbalagemLinha1);
        String tara = getText(taraEmbalagemLinha1);
        Assert.assertEquals(capacidade, "8,50000", "Verificação da capacidade após editar o valor pela tela inicial");
        Assert.assertEquals(tara, "2,60000", "Verificação da tara após editar o valor pela tela inicial");

        editarCampoTelaInicial(capacidadeEmbalagemLinha1, "5");
        editarCampoTelaInicial(taraEmbalagemLinha1, "3");
        click(botaoSalvarAlteracoes);
        tempo();
        capacidade = getText(capacidadeEmbalagemLinha1);
        tara = getText(taraEmbalagemLinha1);
        Assert.assertEquals(capacidade, "5,00000", "Verificação da capacidade após editar o campo pela tela inicial e retornar o valor para o que estava no início do teste");
        Assert.assertEquals(tara, "3,00000", "Verificação da tara após editar o campo pela tela inicial e retornar o valor para o que estava no início do teste");
    }

    public void addRelacaoEmbalagemTransportada() {
        preencherCampoProcurarTelaInicial("00004");
        tempo();
        click(nomeEmbalagemLinha1);
        tempo();
        click(abaRelacaoEmbalagemTransportada);
        tempo();
        click(botaoAddRelacaoEmbalagemTransportada);

        boolean campoCodigo = returnIfElementIsEnabled(campoCodigoRelacaoEmbTransportada);
        Assert.assertEquals(campoCodigo, false, "Verificar se o campo código está desabilitado na tela para adicionar um relação de embalagem transportada");

        tempo();
        clicarCampoSelecionarValor(campoEmbalagemRelacaoEmbTransportada, embSaladaRelacaoEmbTransportada);
        sendKeys(campoQuantidadeRelacaoEmbTransportada, "9");
        click(botaoSalvar);
        String mensagem = getText(mensagemSucesso);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de salvo com sucesso após adicionar uma relação de embalagem transportada");

        String codigo = getText(codigoRelacaoEmbTransportada);
        String nomeEmbalagem = getText(nomeEmbalagemRelacaoEmbTransportada);
        String quantidade = getText(quantRelacaoEmbTransportada);
        Assert.assertEquals(codigo, "00001", "Verificar valor do código da embalagem adicionada na relação de embalagens transportadas");
        Assert.assertEquals(nomeEmbalagem, "SALADA", "Verificar valor do nome da embalagem adicionada na relação de embalagens transportadas");
        Assert.assertEquals(quantidade, "9,00000", "Verificar valor da quantidade da embalagem adicionada na relação de embalagens transportadas");

        click(checkBoxRelacaoEmbTransportada);
        tempo();
        click(botaoExcluirRelacaoEmbalagemTransportada);

        mensagem = getText(mensagemAlertaExclusao);
        mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar no botão excluir na aba de relação de embalagens transportadas");
        click(botaoSimDeletar);

        mensagem = getText(mensagemSucesso);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso após excluir uma relação de embalagem transportada");

        mensagem = getText(mensagemNaoHaRegistroRelacaoEmbTransportada);
        mensagemEsperada = "Não há registros";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem na tela informando que não há registros, após a exclusão da relação de embalagens transportadas");
    }

    public void editarQuantidadeRelacaoEmbTransportada() {
        preencherCampoProcurarTelaInicial("00003");
        click(nomeEmbalagemLinha1);
        click(abaRelacaoEmbalagemTransportada);
        tempo();
        editarCampoTelaInicial(quantRelacaoEmbTransportada, "6,2");
        click(botaoSalvarAlteracoes);
        tempo();
        String quantidade = getText(quantRelacaoEmbTransportada);
        Assert.assertEquals(quantidade, "6,20000", "Verificação do valor da quantidade após a edição na aba relação de embalagens transportadas");

        editarCampoTelaInicial(quantRelacaoEmbTransportada, "4");
        click(botaoSalvarAlteracoes);
        tempo();
        quantidade = getText(quantRelacaoEmbTransportada);
        Assert.assertEquals(quantidade, "4,00000", "Verificação do valor da quantidade após a edição na aba relação de embalagens transportadas, para que o valor volte a ser o mesmo do início do teste");
    }

    public void camposObrigatoriosAddRelacaoEmbTransportada() {
        preencherCampoProcurarTelaInicial("00003");
        click(nomeEmbalagemLinha1);
        click(abaRelacaoEmbalagemTransportada);
        click(botaoAddRelacaoEmbalagemTransportada);
        click(botaoSalvar);

        String codigo = getText(mensagemObrigatorioCodigoRelacaoEmb);
        String embalagem = getText(mensagemObrigatorioEmbalagemRelacaoEmb);
        String quantidade = getText(mensagemObrigatorioQuantRelacaoEmb);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(codigo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo código, para adicionar uma relação de embalagem transportada");
        Assert.assertEquals(embalagem, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo embalagem, para adicionar uma relação de embalagem transportada");
        Assert.assertEquals(quantidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo quantidade, para adicionar uma relação de embalagem transportada");
    }

    public void botaVoltarNaAbaRelacaoEmbalagensTransp() {
        preencherCampoProcurarTelaInicial("00002");
        click(nomeEmbalagemLinha1);
        tempo();
        click(abaRelacaoEmbalagemTransportada);
        tempo();
        click(botaoVoltarRelacaoEmbalagemTransportada);
        tempo();
        boolean encAbaEmbalagensTransportadas = returnIfElementIsVisibility(abaRelacaoEmbalagemTransportada);
        Assert.assertEquals(encAbaEmbalagensTransportadas, false, "Verificar se após clicar no voltar voltar na aba Relação de Embalagens Transportadas, a mesma não está mais visível");
    }

    private void editarCampoTelaInicial(By campo, String texto) {
        Actions actions = new Actions(driver);
        actions.click(driver.findElement(campo)).sendKeys(Keys.BACK_SPACE).build().perform();
        tempo();
        actions.sendKeys(texto).build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        tempo();
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempoParaAguardarTelaInicial();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            tempo();
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
