package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class GrupoDePratoPage extends PageBase   {

    By Inicio = By.xpath("//*[@id='header']/div[1]/div[2]/div[2]");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Grupo de Prato']");
    By telaGrupoDePrato = By.xpath("//div[text() = 'Grupo de Prato']");
    By campoTipo = By.xpath("//*[@id='popup']/span/section/section/section/div/form/section[1]/div/div[1]/div/div/div[2]");
    By tipoContrato = By.xpath("//li[text() = 'Contrato']");
    By tipoPlanejado = By.xpath("//li[text() = 'Planejado']");
    By limpaCampoUnidade = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon='no-border close-x']");
    By buscaUnidade = By.xpath("//div[@id = 'NMFILIAL']//span[@zh-icon='no-border search']");
    By selecionaBusca = By.xpath("//*[@id='grid-9000']/div[2]/div/div/div[1]");
    By btnAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro']");
    By btnAdicionar = By.xpath("//*[@id='footer']/div[2]/ul/li");
    By buscaGrupo = By.xpath("//div[@name = 'NMGRUPOPRATO']//span[@zh-icon='no-border search']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By mensagemAlerta = By.xpath("//div[@class = 'v-dialog v-dialog--active v-dialog--persistent']//div[@class = 'zd-dialog v-card v-sheet theme--light']");
    By buttonOk = By.xpath("//*[@id='dialogButton']");
    By confirmaMensagemAlert = By.xpath("//button[@data-ng-repeat ='button in buttons']");
    By buscaServico = By.xpath("//div[@id = 'NMSERVICO']//span[@zh-icon='no-border search']");
    By buscaAgrupamento = By.xpath("//*[@id='NMAGRUPGRPRAT']/input");

    By clicaAgrupamento = By.xpath("//*[@id='grid-7033584734288389656314']/div[2]/div/div/div[1]");
    By novoAgrupamento = By.xpath("/html/body/span/section/section/div[2]/section[3]/div[2]/div[4]/section/section/div/section/div/form/section/div/div[2]/div/div/div[3]/span[2]");
    By abaGrupoDePrato = By.xpath("//label[@class = 'zh-tab-cell']//*[text() = 'Grupo de Prato']");
    By marcaServico = By.xpath("//*[@id='grid-7033584732952607201292']/div[2]/div/div[1]/div[1]");
    By btnExcluir = By.xpath("//*[@id='footer']/div[2]/ul/li");
    By btnExcluirGrupo = By.xpath("//*[@id='footer']/div[2]/ul/li[2]");
    By confirmAlert = By.xpath("//span[text() = 'Sim']");
    By cdServico = By.xpath("//*[@id='grid-7033584732952607201292']/div[2]/div/div/div[2]/span");
    By nmServico = By.xpath("//*[@id='grid-7033584732952607201292']/div[2]/div/div/div[3]/span");
    By nmAgrupamento = By.xpath("//*[@id='grid-7033584732952607201292']/div[2]/div/div/div[4]/span");

    //Campos do botão de pesquisa
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div");
    By botaoPesquisarFiltro = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/span[1]");
    By campoProcurar = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaAgrupamento = By.xpath("/html/body/span/section/section/div[2]/section[3]/div[2]/div[4]/section/section/div/section/div/form/section/div/div[2]/div/div/div[3]/span[1]");


    public void acessarTela(){
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        acessarTela(pesquisaTela,"Grupo de Prato");
        tempo();
        click(selecionaTela);
        tempo();
        waitForElement(telaGrupoDePrato);
        tempo();

    }

    public void realizarFiltro(String tipoDeContrato, String cdUnidade){
        tempo();
        if (tipoDeContrato == "Contrato"){
            click(campoTipo);
            tempo();
            click(tipoContrato);
        }
        click(limpaCampoUnidade);
        click(buscaUnidade);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,cdUnidade);
        click(selecionaBusca);
        tempo();
        click(btnAplicarFiltro);
        tempo();

    }

    public void cadastrarGrupo(String cdGrupo, String cdServico){
        tempo();
        click(btnAdicionar);
        tempo();
        click(buscaGrupo);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,cdGrupo);
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        tempo();
        click(confirmaMensagemAlert);
        tempo();
        click(buscaServico);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,cdServico);
        click(selecionaBusca);
        tempo();
        click(buscaAgrupamento);
        tempo();
        click(selecionaAgrupamento);
        tempo();
        click(btnSalvar);
        tempo();
        tempo();
    }

    public void alterarGrupo(String cdServico){
        tempo();
        click(clicaAgrupamento);
        tempo();
        click(btnAdicionar);
        tempo();
        click(buscaServico);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,cdServico);
        click(selecionaBusca);
        tempo();
        click(buscaAgrupamento);
        tempo();
        click(novoAgrupamento);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String retornaCodigoServico(){
        return getText(cdServico);
    }

    public String retornaNomeServico(){
        return getText(nmServico);
    }

    public String retornaNomeAgrupamento(){
        return getText(nmAgrupamento);
    }

    public void excluirServicoGrupoPlanejamento(){
        click(clicaAgrupamento);
        tempo();
        click(marcaServico);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmAlert);
        tempo();

    }

    public void excluirGrupoDePrato(){
        click(clicaAgrupamento);
        tempo();
        click(marcaServico);
        tempo();
        click(btnExcluir);
        tempo();
        click(confirmAlert);
        tempo();
        click(abaGrupoDePrato);
        tempo();
        click(btnExcluirGrupo);
        tempo();
        click(confirmAlert);
        tempo();

    }

    public void validarRegistroIgual(){
        tempo();
        click(btnAdicionar);
        tempo();
        click(buscaGrupo);
        tempo();
        preencherCampoProcurarTelaInicial(botaoAbrirOpcoesControleTelaInicial,botaoPesquisarFiltro,campoProcurar,"000000001");
        click(selecionaBusca);
        click(btnSalvar);
        tempo();
        click(confirmaMensagemAlert);
        tempo();



    }




}
