package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.time.temporal.Temporal;

public class ParametrosDePlanejamentoPage extends PageBase {

    By Inicio = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By pesquisaTela = By.xpath("//section[@class = 'zh-container-search-menu']/input");
    By selecionaTela = By.xpath("//span[text() = 'Parâmetros de Planejamento']");
    By confirmaTela = By.xpath("//div[text() = 'Parâmetros de Planejamento']");
    By abaPersonalizacao = By.xpath("//span[text() = ' Personalização']");
    By btnEditar = By.xpath("//li[@data-zh-id='2439777433150567371275']");
    By utilizaTipoCardapio = By.xpath("//div[@class = 'zh-select-native-div']/div[2]");
    By opcaoPadronizado = By.xpath("//li[text() = 'Padronizado']");
    By opcaoLivre = By.xpath("//li[text() = 'Livre']");
    By opcaoDescentralizado = By.xpath("//li[text() = 'Que Depende de Liberação (Descentralizado)']");
    By filtroUnidadePadrao = By.xpath("//span[@zh-icon='no-border search']");
    By limpaUnidadePadrão = By.xpath("//span[@zh-icon= 'no-border close-x']");
    By abreFiltroBusca = By.xpath("//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By insereInformacao = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By selecionaBusca = By.xpath("//div[@class = 'tr cell1']");
    By btnSalvar = By.xpath("//span[text() = 'Salvar']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");

    //Aba Cardápio

    By abaCardapio = By.xpath("//span[text() = ' Cardápio']");
    By editarAbaCardapio = By.xpath("//li[@data-zh-id='2439777432013325810349']");
    By limpaCampoCarboidrato = By.xpath("//div[@id = 'NMCARBOHIDRA']//span[@zh-icon='no-border close-x']");
    By buscaCarboidrato = By.xpath("//div[@id = 'NMCARBOHIDRA']//span[@zh-icon='no-border search']");
    By clicaMenuFiltro = By.xpath("//div[@class = 'control-handle']");
    By limpaCampoAlcool = By.xpath("//div[@id = 'NMALCOOL']//span[@zh-icon='no-border close-x']");
    By buscaAlcool = By.xpath("//div[@id = 'NMALCOOL']//span[@zh-icon='no-border search']");
    By limpaCampoLipidio = By.xpath("//div[@id = 'NMLIPIDIOS']//span[@zh-icon='no-border close-x']");
    By buscaLipidio = By.xpath("//div[@id = 'NMLIPIDIOS']//span[@zh-icon='no-border search']");
    By limpaCampoAcidosGraxos = By.xpath("//div[@id = 'NMACIDGRAXOS']//span[@zh-icon='no-border close-x']");
    By buscaAcidoGraxos = By.xpath("//div[@id = 'NMACIDGRAXOS']//span[@zh-icon='no-border search']");
    By limpaCampoCaloria = By.xpath("//div[@id = 'NMCALORIAS']//span[@zh-icon='no-border close-x']");
    By buscaCaloria = By.xpath("//div[@id = 'NMCALORIAS']//span[@zh-icon='no-border search']");
    By limpaCampoSodio = By.xpath("//div[@id = 'NMSODIO']//span[@zh-icon='no-border close-x']");
    By buscaSodio = By.xpath("//div[@id = 'NMSODIO']//span[@zh-icon='no-border search']");
    By limpaCampoProteina = By.xpath("//div[@id = 'NMPROTEINA']//span[@zh-icon='no-border close-x']");
    By buscaProteina = By.xpath("//div[@id = 'NMPROTEINA']//span[@zh-icon='no-border search']");
    By limpaCampoProteinaVegetal = By.xpath("//div[@id = 'NMPROTVEGETA']//span[@zh-icon='no-border close-x']");
    By buscaProteinaVegetal = By.xpath("//div[@id = 'NMPROTVEGETA']//span[@zh-icon='no-border search']");
    By limpaCampoProteinaAnimal = By.xpath("//div[@id = 'NMPROTANIMAL']//span[@zh-icon='no-border close-x']");
    By buscaProteinaAnimal = By.xpath("//div[@id = 'NMPROTANIMAL']//span[@zh-icon='no-border search']");
    By limpaCampoAcucares = By.xpath("//div[@id = 'NMACUCARES']//span[@zh-icon='no-border close-x']");
    By buscaAcucares = By.xpath("//div[@id = 'NMACUCARES']//span[@zh-icon='no-border search']");
    By limpaCampoFibras = By.xpath("//div[@id = 'NMFIBRAS']//span[@zh-icon='no-border close-x']");
    By buscaFibras = By.xpath("//div[@id = 'NMFIBRAS']//span[@zh-icon='no-border search']");
    By limpaCampoGluten = By.xpath("//div[@id = 'NMGLUTEN']//span[@zh-icon='no-border close-x']");
    By buscaGluten = By.xpath("//div[@id = 'NMGLUTEN']//span[@zh-icon='no-border search']");
    By limpaCampoLactose = By.xpath("//div[@id = 'NMLACTOSE']//span[@zh-icon='no-border close-x']");
    By buscaLactose = By.xpath("//div[@id = 'NMLACTOSE']//span[@zh-icon='no-border search']");
    By checkBoxConsisteAtualizaEfetivos = By.xpath("//label[@for='zh-checkbox-IDCONSMINEFE']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxObrigaInformarEfetivos = By.xpath("//label[@for='zh-checkbox-IDBLOQEFET']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxLancaComensalSemPrato = By.xpath("//label[@for='zh-checkbox-IDPERCOMENSPRAT']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxConsideraReceitaRevisada = By.xpath("//label[@for='zh-checkbox-IDRECREVICOP']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxPermitePratoReceitaPadrao = By.xpath("//label[@for='zh-checkbox-IDUTRPADCA']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By diasBloqueioIncluseDtProcessamento = By.xpath("//input[@name = 'QTDIABLOQCAR']");
    By checkBoxBloqueiaInclusaoPratoLocal = By.xpath("//label[@for = 'zh-checkbox-IDBLOPRATLOC']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxBloqueiaCodigoPratoPadraoIgualLocal = By.xpath("//label[@for = 'zh-checkbox-IDBLOQPRADUP']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxBuscaPratoPorNome = By.xpath("//label[@for = 'zh-checkbox-IDPESQPRATNOME']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxVisualizaComplementoProduto = By.xpath("//label[@for = 'zh-checkbox-IDPESQCOMPPROD']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxMantemCoresCardapio = By.xpath("//label[@for = 'zh-checkbox-IDMANCORCARDALT']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By buscaAgrupamentoProdutoRevisaoReceita = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMGRUPPROD zh-text-align-left']/span");
    By limpaAgrupamentoProdutoRevisaoReceita = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMGRUPPROD zh-text-align-left']//span[@zh-icon='no-border close-x']");
    By qtdMesesHistoricoAjusteCardapio = By.xpath("//*[@id = 'NRMESHISTCARD']");

    //Aba Cálculo do NDPCAL
    By abaCalculoNdpcal = By.xpath("//span[text() = ' Cálculo do NDPCAL']");
    By btnAdicionar = By.xpath("//li[@data-zh-id='2439777434284754287380']");
    By buscaProduto = By.xpath("//span[@zh-icon='no-border search']");
    By clicaFatorCalculo = By.xpath("//div[@class = 'editable-content']");
    By insereFatorCalculo = By.xpath("//input[@id = 'VRFATCALNDPC']");
    By atualizaFatorCalculo = By.xpath("//*[@id='grid-2439777434170190933367']/div[2]/div/div/div[4]/div/input");
    By apagarProdutoNdpcal = By.xpath("//div[@class = 'td left-grid-actions fixed']");
    By confirmaExclusao = By.xpath("//button[@class = 'zh-alert-button horizontal']//span[text() = 'Sim']");
    By validaExclusao = By.xpath("//p[text() = 'Não há registros']");
    By btnOk = By.xpath("//button[@class = 'zh-alert-button']");
    By btnCancelar = By.xpath("//span[text() = 'Cancelar']");
    By clicarTela = By.xpath("//*[@class = 'body-content']");
    By btnSalvarAlteracoes = By.xpath("//*[text() = 'Salvar alterações']");

    //Aba Safra
    By abaSafra = By.xpath("//span[text() = ' Safra']");
    By btnAdicionarSafra = By.xpath("//li[@data-zh-id='243977743747693241399']");
    By insereInicioFaixa = By.xpath("//*[@id = 'VRLIMINFSAFR']");
    By insereFimFaixa = By.xpath("//*[@id = 'VRLIMSUPSAFR']");
    By insereDescricao = By.xpath("//*[@id = 'NMSINASAFRA']");
    By clicaCampoCor = By.xpath("//*[@id= 'NRCORSINSAFR']");
    By corAzulSafra = By.xpath("//*[@id='popup']/span/section/section/section/section/div[2]/div[1]");
    By btnOkSafra = By.xpath("//span[text() = 'Ok']");
    By apagaSafra = By.xpath("//div[@class = 'td left-grid-actions fixed']");
    By confirmaMensagem = By.xpath("//button[@class = 'zh-alert-button']//span[text() = 'OK']");
    By editaDescricao = By.xpath("//*[@id='grid-2439777431168264931389']/div[2]/div/div[2]/div[4]/div");
    By insereNovaDescricao = By.xpath("//*[@id='grid-2439777431168264931389']/div[2]/div/div[2]/div[4]/div/input");
    By clicaRegistro = By.xpath("//div[@class = 'tr cell1']");
    By btnEditarSafra = By.xpath("//li[@data-zh-id='2439777432292377574401']");
    By btnExcluirSafra = By.xpath("//li[@data-zh-id='2439777432623872148403']");
    By vermelhoSafra = By.xpath("//*[@id='popup']/span/section/section/section/section/div[2]/div[5]");
    By amareloSafra = By.xpath("//*[@id='popup']/span/section/section/section/section/div[2]/div[3]");
    By msgEsperada = By.xpath("//*[text() = 'AUTOMAÇÃO']");
    By msgEsperada_1 = By.xpath("//*[text() = 'TESTE AUTOMAÇÃO']");
    By valorInicioFaixa = By.xpath("//*[@id='grid-2439777431168264931389']/div[2]/div/div[1]/div[2]//*[text() = '1']");
    By valorFinalFaixa = By.xpath("//*[@id='grid-2439777431168264931389']/div[2]/div/div[1]/div[3]//*[text() = '1']");
    By valorInicialFaixa = By.xpath("//*[@id='grid-2439777431168264931389']/div[2]/div/div[2]/div[2]//*[text() = '2']");
    By valorFaixaFim = By.xpath("//*[@id='grid-2439777431168264931389']/div[2]/div/div[2]/div[3]//*[text() = '2']");

    //Grupo de Operadores
    By abaGrupoDeOperadores = By.xpath("//*[text() = ' Grupo de Operadores']");
    By editaGrupoOperadores = By.xpath("//*[@data-zh-id='2439777433248022516454']");
    By limpaCampoAutorizacaoAlterarRequisicaoPorServico = By.xpath("//div[@id = 'DSGROPERRESE']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoAlterarRequisicaoPorServico = By.xpath("//div[@id = 'DSGROPERRESE']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoAlterarRequisicaoExtra = By.xpath("//div[@id ='DSGROPERREEX']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoAlterarRequisicaoExtra = By.xpath("//div[@id ='DSGROPERREEX']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoAlterarReceitaPadrao = By.xpath("//div[@id = 'DSGROPERREPA']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoReceitaPadrao = By.xpath("//div[@id = 'DSGROPERREPA']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoAlterarreceitaRevisada = By.xpath("//div[@id = 'DSGRUPOPERARRV']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoReceitaRevisada = By.xpath("//div[@id = 'DSGRUPOPERARRV']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoGravarDtRefCusto = By.xpath("//div[@id = 'DSGRUPOPERRCUS']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoGravarDtRefCusto = By.xpath("//div[@id = 'DSGRUPOPERRCUS']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoGravarDtRefRecauculoCusto = By.xpath("//div[@ id = 'DSGRUPOPERRECC']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoGravarDtRefRecauculoCusto = By.xpath("//div[@id = 'DSGRUPOPERRECC']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoLiberarCardapioForaMeta = By.xpath("//div[@id = 'DSGRUPOPERLCMR']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAltorizacaoLiberarCardapioForaMeta = By.xpath("//div[@id = 'DSGRUPOPERLCMR']//span[@zh-icon = 'no-border search']");
    By limpaCampoAlteracaoCustoPadrao = By.xpath("//div[@id = 'DSGRUPOPERACPS']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAlteracaoCustoPadrao = By.xpath("//div[@id = 'DSGRUPOPERACPS']//span[@zh-icon = 'no-border search']");
    By limpaCampoLiberaRevisaoCardDescentralizado = By.xpath("//div[@id = 'DSGRUPOPERLRCD']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoLiberaRevisaoCardDescentralizado = By.xpath("//div[@id = 'DSGRUPOPERLRCD']//span[@zh-icon = 'no-border search']");
    By limpaCampoAutorizacaoSubstituirPratoCardLiberado= By.xpath("//div[@id = 'DSGRUPOPERSBTP']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAutorizacaoSubstituirPratoCardLiberado = By.xpath("//div[@id = 'DSGRUPOPERSBTP']//span[@zh-icon = 'no-border search']");
    By limpaCampoAcessoOtimizador= By.xpath("//div[@id = 'DSOTIMIZADORCARD']//span[@zh-icon = 'no-border close-x']");
    By buscaGrupoAcessoOtimizador = By.xpath("//div[@id = 'DSOTIMIZADORCARD']//span[@zh-icon = 'no-border search']");

    By valorRequisicaoPorServico = By.xpath("//*[@id='span-field-DSGROPERRESE']//p[text() = '6 | ADMINISTRADOR']");
    By valorRequisicaoExtra = By.xpath("//*[@id='span-field-DSGROPERREEX']//p[text() = '6 | ADMINISTRADOR']");
    By valorReceitasPadrao = By.xpath("//*[@id='span-field-DSGROPERREPA']//p[text() = '6 | ADMINISTRADOR']");
    By valorReceitaRevisada = By.xpath("//*[@id='span-field-DSGRUPOPERARRV']//p[text() = '6 | ADMINISTRADOR']");
    By valorDtReferenciaCusto = By.xpath("//*[@id='span-field-DSGRUPOPERRCUS']//p[text() = '6 | ADMINISTRADOR']");
    By valorDataRefRecalculoCusto = By.xpath("//*[@id='span-field-DSGRUPOPERRECC']//p[text() = '6 | ADMINISTRADOR']");
    By valorLiberarCardapioForaMeta = By.xpath("//*[@id='span-field-DSGRUPOPERLCMR']//p[text() = '6 | ADMINISTRADOR']");
    By valorCustoPadrao = By.xpath("//*[@id='span-field-DSGRUPOPERACPS']//p[text() = '6 | ADMINISTRADOR']");
    By valorCardapioDescentralizado = By.xpath("//*[@id='span-field-DSGRUPOPERLRCD']//p[text() = '6 | ADMINISTRADOR']");
    By valorSubstituirPratoLiberadoProd = By.xpath("//*[@id='span-field-DSGRUPOPERSBTP']//p[text() = '6 | ADMINISTRADOR']");
    By valorAcessoOtimizador = By.xpath("//*[@id='span-field-DSOTIMIZADORCARD']//p[text() = '6 | ADMINISTRADOR']");

    //Avisos para Aprovação de Cardápio
    By abaAvisosAprovacaoCardapio = By.xpath("//*[text() = ' Avisos para Aprovação de Cardápio']");
    By cardapioBloqueado = By.xpath("//*[@id = 'DSMENSAPROVCARD']");
    By btnAdicionarAviso = By.xpath("//li[@data-zh-id='2439777433203681082477']");
    By qtdDias = By.xpath("//input[@id = 'QTDIAMENS']");
    By mensagemCardapio = By.xpath("//div[@data-zh-id='2439777432918520146295']//input[@id = 'DSMENSAPROVCARD']");
    By retornaQtdDias = By.xpath("//div[@data-zh-field-name='QTDIAMENS']//span[text() = '5']");
    By retornaMensagem = By.xpath("//span[text() = 'Aprovação de Cardápio Próximo da data Limite!!']");
    By retornarQtdDias = By.xpath("//div[@data-zh-field-name='QTDIAMENS']//span[text() = '3']");
    By retornarMensagem = By.xpath("//span[text() = 'Aprovação de Cardápio!!']");
    By clicarMensagemAviso = By.xpath("//div[@class = 'editable-content']");
    By novaMensagemAviso = By.xpath("//div[@class = 'editable-content']/input");
    By clicaMensagemAviso = By.xpath("//*[@id='grid-243977743747324963470']/div[2]/div/div[2]/div[3]/div");
    By insereNovamMensagemAviso = By.xpath("//*[@id='grid-243977743747324963470']/div[2]/div/div[2]/div[3]/div/input");
    By retornaNovaMensagemAviso = By.xpath("//span[text() = 'Aprovar Cardápio Urgente!!']");
    By retornarNovaMensamenAviso = By.xpath("//span[text() = 'Tempo limite para aprovação chegando!!']");
    By btnExcluirMsgAviso = By.xpath("//div[@class = 'td left-grid-actions fixed']");

    //Avaliação VET
    By abaAvaliacaoVet = By.xpath("//span[text() = ' Avaliação VET']");
    By btnAdicionarAvaliacao = By.xpath("//li[@data-zh-id='243977743220238357509']");
    By buscaGrupoServico = By.xpath("//div[@id = 'NMGRUPSERV']//span[@zh-icon='no-border search']");
    By limpaGrupoServuco = By.xpath("//div[@id = 'NMGRUPSERV']//span[@zh-icon='no-border close-x']");
    By selecionaGrupoServico = By.xpath("//span[text() = '005 | ENTREGAS']");
    By novoGrupoServico = By.xpath("//span[text() = '003 | COMPRAS']");
    By clicarCampoGrupoServico = By.xpath("//div[@id = 'NMGRUPSERV']");
    By inseredescricaoCal = By.xpath("//input[@id = 'DSCAL']");

    //Validndo Cadastro VET
    By valorCho = By.xpath("//input[@id = 'VRPERCENTCHO']");
    By valorPtn = By.xpath("//input[@id = 'VRPERCENTPTN']");
    By valorLip = By.xpath("//input[@id = 'VRPERCENTLIP']");
    By retornaValorDescricao = By.xpath("//span[text() = 'NUTRIENTES']");
    By retornaValorCho = By.xpath("//span[text() = '90,000']");
    By retornaValorPtn = By.xpath("//span[text() = '5,000']");
    By retornaValorLip = By.xpath("//span[text() = '5,000']");
    By retornarValorDescricao = By.xpath("//span[text() = 'COMPRAS']");
    By retornarValorCho = By.xpath("//span[text() = '50,000']");
    By retornarValorPtn = By.xpath("//span[text() = '25,000']");
    By retornarValorLip = By.xpath("//span[text() = '25,000']");

    //Ações de editar
    By editarDescCalComp = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[4]/div");
    By inserirNovaDesc = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[4]/div/input");
    By editarDescCalNutr = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[4]/div");
    By insereNovaDesc = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[4]/div/input");
    By clicarVetCho = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[5]/div");
    By novoValorVetCho = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[5]/div/input");
    By clicarVetPtn = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[6]/div");
    By novoValorVetPtn = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[6]/div/input");
    By clicarVetLip = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[7]/div");
    By novoValorVetLip = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[7]/div/input");
    By clicaVetCho = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[5]/div");
    By novoValVetCho = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[5]/div/input");
    By clicaVetPtn = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[6]/div");
    By novoValVetPtn = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[6]/div/input");
    By clicaVetLip = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[7]/div");
    By novoValVetLip = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[2]/div[7]/div/input");
    By retornaDescricaoAtu = By.xpath("//div[@class = 'tr cell1']//span[text() = 'AUTOMAÇÃO']");
    By retornarDescricaoAtu = By.xpath("//div[@class = 'tr cell2']//span[text() = 'AUTOMAÇÃO']");
    By valorChoAtu = By.xpath("//span[text() = '60,000']");
    By valorPtnAtu = By.xpath("//span[text() = '20,000']");
    By valorLipAtu = By.xpath("//span[text() = '20,000']");
    By valChoAtu = By.xpath("//span[text() = '40,000']");
    By valPtnAtu = By.xpath("//span[text() = '40,000']");
    By valLipAtu = By.xpath("//span[text() = '20,000']");

    //Excluindo Avaliacao VET
    By btnExcluirAvaliacao = By.xpath("//*[@id='grid-2439777431018950623491']/div[2]/div/div[1]/div[1]");


    public void acessarTela(){
        tempo();
        waitForElement(Inicio);
        tempo();
        click(clicaMenu);
        tempo();
        click(pesquisaTela);
        clearAndSendKeys(pesquisaTela,"Parâmetros de Planejamento");
        tempo();
        click(selecionaTela);
        tempo();
        tempo();
    }

    public String validaAcessoTela(){
        return getText(confirmaTela);
    }

    public void editaPersonalizacao(){
        tempo();
        click(abaPersonalizacao);
        tempo();
        click(btnEditar);
        tempo();
        click(utilizaTipoCardapio);
        tempo();
        click(opcaoPadronizado);
        tempo();
        click(filtroUnidadePadrao);
        tempo();
        click(abreFiltroBusca);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"0002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnEditar);
        tempo();
        click(limpaUnidadePadrão);
        tempo();
        click(utilizaTipoCardapio);
        tempo();
        click(opcaoDescentralizado);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnEditar);
        tempo();
        click(utilizaTipoCardapio);
        click(opcaoLivre);
        click(btnSalvar);
        tempo();
        click(btnVoltar);
    }

    public void editarAbaCardapio(){
        tempo();
        click(abaCardapio);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(limpaCampoCarboidrato);
        click(limpaCampoAlcool);
        click(limpaCampoLipidio);
        click(limpaCampoAcidosGraxos);
        click(limpaCampoCaloria);
        click(limpaCampoSodio);
        click(limpaCampoProteina);
        click(limpaCampoProteinaVegetal);
        click(limpaCampoProteinaAnimal);
        click(limpaCampoAcucares);
        click(limpaCampoFibras);
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(buscaCarboidrato);
        tempo();
        click(abreFiltroBusca);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"019");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaAlcool);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"011");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaLipidio);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"006");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaAcidoGraxos);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"007");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaCaloria);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"010");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaSodio);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"003");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaProteina);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"021");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaProteinaVegetal);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"001");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaProteinaAnimal);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"018");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaAcucares);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"002");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaFibras);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"015");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        scrollParametrosPla();
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(buscaGluten);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"15");
        tempo();
        click(selecionaBusca);
        click(buscaLactose);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"14");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(limpaCampoGluten);
        click(limpaCampoLactose);
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(checkBoxConsisteAtualizaEfetivos);
        click(checkBoxObrigaInformarEfetivos);
        click(checkBoxLancaComensalSemPrato);
        click(checkBoxConsideraReceitaRevisada);
        click(checkBoxPermitePratoReceitaPadrao);
        tempo();
        click(diasBloqueioIncluseDtProcessamento);
        clearAndSendKeys(diasBloqueioIncluseDtProcessamento,"2");
        click(checkBoxBloqueiaInclusaoPratoLocal);
        click(checkBoxBloqueiaCodigoPratoPadraoIgualLocal);
        click(checkBoxBuscaPratoPorNome);
        click(checkBoxVisualizaComplementoProduto);
        click(checkBoxMantemCoresCardapio);
        tempo();
        click(buscaAgrupamentoProdutoRevisaoReceita);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"0000000001");
        tempo();
        click(selecionaBusca);
        tempo();
        click(qtdMesesHistoricoAjusteCardapio);
        clearAndSendKeys(qtdMesesHistoricoAjusteCardapio,"3");
        tempo();
        click(btnSalvar);
        tempo();
        click(editarAbaCardapio);
        tempo();
        click(limpaAgrupamentoProdutoRevisaoReceita);
        click(btnSalvar);
        scrollParametrosPla();
        scrollParametrosPla();
        scrollParametrosPla();
        click(btnVoltar);
    }

    public void calculoNdpcal(){
        tempo();
        click(abaCalculoNdpcal);
        tempo();
        for (int i = 0; i < 2; i++){
            click(btnAdicionar);
            tempo();
            click(buscaProduto);
            tempo();
            click(insereInformacao);
            clearAndSendKeys(insereInformacao, "REFEIÇÕES TRANSPORTADAS");
            tempo();
            click(selecionaBusca);
            tempo();
            click(insereFatorCalculo);
            clearAndSendKeys(insereFatorCalculo, "2");
            tempo();
            click(btnSalvar);
        }
        tempo();
        click(btnOk);
        tempo();
        click(btnCancelar);
        tempo();
        Assert.assertEquals("REFEIÇÕES TRANSPORTADAS","REFEIÇÕES TRANSPORTADAS");
        click(clicaFatorCalculo);
        clearAndSendKeys(atualizaFatorCalculo,"3");
        click(clicarTela);
        click(btnSalvarAlteracoes);
        tempo();
        Assert.assertEquals("REFEIÇÕES TRANSPORTADAS","REFEIÇÕES TRANSPORTADAS");
        tempo();
        click(apagarProdutoNdpcal);
        tempo();
        click(confirmaExclusao);
        tempo();

    }

    public void cadastraSafra(){
        click(abaSafra);
        tempo();
        click(btnAdicionarSafra);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnOk);
        tempo();
        click(btnCancelar);
        for (int i = 0; i < 2; i++) {
            tempo();
            click(btnAdicionarSafra);
            tempo();
            clickPerform(insereInicioFaixa);
            clearAndSendKeys(insereInicioFaixa, "1");
            clickPerform(insereFimFaixa);
            clearAndSendKeys(insereFimFaixa, "1");
            clickPerform(insereDescricao);
            clearAndSendKeys(insereDescricao, "Teste");
            tempo();
            click(clicaCampoCor);
            tempo();
            click(corAzulSafra);
            tempo();
            click(btnOkSafra);
            tempo();
            click(btnSalvar);
        }
        click(confirmaMensagem);
        tempo();
        click(insereInicioFaixa);
        clearAndSendKeys(insereInicioFaixa,"2");
        click(clicaCampoCor);
        tempo();
        click(vermelhoSafra);
        click(btnOkSafra);
        tempo();
        click(btnSalvar);
        tempo();
        click(confirmaMensagem);
        tempo();
        click(insereFimFaixa);
        clearAndSendKeys(insereFimFaixa,"2");
        tempo();
        click(btnSalvar);
    }

    public void editarSafra(){
        tempo();
        click(editaDescricao);
        click(insereNovaDescricao);
        clearAndSendKeys(insereNovaDescricao,"AUTOMAÇÃO");
        click(clicarTela);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(clicaRegistro);
        tempo();
        click(btnEditarSafra);
        tempo();
        click(insereDescricao);
        clearAndSendKeys(insereDescricao,"TESTE AUTOMAÇÃO");
        tempo();
        click(clicaCampoCor);
        tempo();
        click(amareloSafra);
        tempo();
        click(btnOkSafra);
        tempo();
        click(btnSalvar);
        tempo();
    }

    public void apagarSafra(){
        click(clicaRegistro);
        tempo();
        click(btnExcluirSafra);
        tempo();
        click(confirmaExclusao);
        tempo();
        click(apagaSafra);
        tempo();
        click(confirmaExclusao);
        tempo();
    }

    public String validarExclusao(){
        return getText(validaExclusao);
    }

    public String validaEdicao(){
        return getText(msgEsperada_1);
    }

    public String validarEdicao(){
        return getText(msgEsperada);
    }

    public String validaCadastro(){return getText(valorInicioFaixa);}

    public String confirmaCadastro(){return getText(valorFinalFaixa);}

    public String confirmarCadastro(){return getText(valorInicialFaixa);}

    public String validarCadastro(){return getText(valorFaixaFim);}

    public void grupoDeOperadores(){
        click(abaGrupoDeOperadores);
        tempo();
        click(editaGrupoOperadores );
        tempo();
        click(limpaCampoAutorizacaoAlterarRequisicaoPorServico);
        click(limpaCampoAutorizacaoAlterarRequisicaoExtra);
        click(limpaCampoAutorizacaoAlterarReceitaPadrao);
        click(limpaCampoAutorizacaoAlterarreceitaRevisada);
        click(limpaCampoAutorizacaoGravarDtRefCusto);
        click(limpaCampoAutorizacaoGravarDtRefRecauculoCusto);
        click(limpaCampoAutorizacaoLiberarCardapioForaMeta);
        click(limpaCampoAlteracaoCustoPadrao);
        click(limpaCampoLiberaRevisaoCardDescentralizado);
        click(limpaCampoAutorizacaoSubstituirPratoCardLiberado);
        click(limpaCampoAcessoOtimizador);
        tempo();
        click(btnSalvar);
        tempo();
        click(editaGrupoOperadores);
        tempo();
        click(buscaGrupoAltorizacaoAlterarRequisicaoPorServico );
        tempo();
        click(abreFiltroBusca);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAltorizacaoAlterarRequisicaoExtra);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAltorizacaoReceitaPadrao);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAltorizacaoReceitaRevisada);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAltorizacaoGravarDtRefCusto);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAltorizacaoGravarDtRefRecauculoCusto);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAltorizacaoLiberarCardapioForaMeta);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAlteracaoCustoPadrao);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoLiberaRevisaoCardDescentralizado);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAutorizacaoSubstituirPratoCardLiberado);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(buscaGrupoAcessoOtimizador);
        tempo();
        click(insereInformacao);
        clearAndSendKeys(insereInformacao,"6");
        tempo();
        click(selecionaBusca);
        tempo();
        click(btnSalvar);
        tempo();

    }

    public String retornaGrupoReqServico(){
        return getText(valorRequisicaoPorServico);
    }

    public String retornaGrupoReqExtra(){
        return getText(valorRequisicaoExtra);
    }

    public String retornaGrupoReceitaPadrao(){
        return getText(valorReceitasPadrao);
    }

    public String retornaGrupoReceitaRevisada(){
        return getText(valorReceitaRevisada);
    }

    public String retornaGrupoDtRefCusto(){
        return getText(valorDtReferenciaCusto);
    }

    public String retornaGrupoDtRefRecalculoCusto(){
        return getText(valorDataRefRecalculoCusto);
    }

    public String retornaGrupoLiberaCardForaMeta(){
        return getText(valorLiberarCardapioForaMeta);
    }

    public String retornaGrupoCustoPadrao(){
        return getText(valorCustoPadrao);
    }

    public String retornaGrupoCardDescentralizado(){
        return getText(valorCardapioDescentralizado);
    }

    public String retornaGrupoSubstPratoCardLiberadoProducao(){
        return getText(valorSubstituirPratoLiberadoProd);
    }

    public String retornaGrupoAcessoOtimizador(){
        return getText(valorAcessoOtimizador);
    }

    public void avisosAprovacaoCardapio(){
        tempo();
        click(abaAvisosAprovacaoCardapio);
        tempo();
        for (int i = 0; i < 2; i++){
        click(btnAdicionarAviso);
        tempo();
        click(qtdDias);
        clearAndSendKeys(qtdDias,"5");
        tempo();
        click(mensagemCardapio);
        clearAndSendKeys(mensagemCardapio,"Aprovação de Cardápio Próximo da data Limite!!");
        tempo();
        click(btnSalvar);}
        tempo();
        click(btnOk);
        click(qtdDias);
        clearAndSendKeys(qtdDias,"3");
        tempo();
        click(mensagemCardapio);
        clearAndSendKeys(mensagemCardapio,"Aprovação de Cardápio!!");
        click(btnSalvar);
        tempo();
    }

    public String validaCadastroDiasAviso(){return getText(retornaQtdDias);}

    public String validaCadastroMensagemAviso(){
        return getText(retornaMensagem);
    }

    public String validarCadastroDiasAviso(){return getText(retornarQtdDias);}

    public String validarCadastroMensagemAviso(){
        return getText(retornarMensagem);
    }

    public void editarMensagemAviso(){
        click(clicarMensagemAviso);
        clear(novaMensagemAviso);
        click(clicaMensagemAviso);
        clear(insereNovamMensagemAviso);
        tempo();
        click(clicarTela);
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
        click(btnOk);
        tempo();
        click(clicarMensagemAviso);
        clearAndSendKeys(novaMensagemAviso,"Aprovar Cardápio Urgente!!");
        tempo();
        click(clicaMensagemAviso);
        clearAndSendKeys(insereNovamMensagemAviso,"Tempo limite para aprovação chegando!!");
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
    }

    public String validaEdicaoMensagem(){return getText(retornaNovaMensagemAviso);}

    public String confirmaEdicaoMensagem(){return getText(retornarNovaMensamenAviso);}

    public void apagarMensagemAviso(){
        tempo();
        click(btnExcluirMsgAviso);
        tempo();
        click(confirmaExclusao);
        tempo();
        click(btnExcluirMsgAviso);
        tempo();
        click(confirmaExclusao);
        tempo();
    }

    public void cadastraAvaliacaoVet(){
        tempo();
        click(abaAvaliacaoVet);
        tempo();
        for (int i = 0; i < 2; i++) {
        click(btnAdicionarAvaliacao);
        tempo();
        click(btnSalvar);
        tempo();
        click(btnOk);
        clickPerform(clicarCampoGrupoServico);
        click(selecionaGrupoServico);
        tempo();
        clickPerform(inseredescricaoCal);
        clearAndSendKeys(inseredescricaoCal, "NUTRIENTES");
        clickPerform(valorCho);
        clearAndSendKeys(valorCho, "90");
        clickPerform(valorPtn);
        clearAndSendKeys(valorPtn, "5");
        clickPerform(valorLip);
        clearAndSendKeys(valorLip, "5");
        tempo();
        click(btnSalvar);
        }
        tempo();
        click(btnOk);
        tempo();
        click(limpaGrupoServuco);
        clickPerform(clicarCampoGrupoServico);
        click(novoGrupoServico);
        clickPerform(inseredescricaoCal);
        tempo();
        clearAndSendKeys(inseredescricaoCal, "COMPRAS");
        tempo();
        clickPerform(valorCho);
        clearAndSendKeys(valorCho,"100");
        clickPerform(valorPtn);
        clearAndSendKeys(valorPtn,"100");
        clickPerform(valorLip);
        clearAndSendKeys(valorLip,"100");
        tempo();
        click(btnSalvar);
        tempo();
        click(btnOk);
        tempo();
        clickPerform(valorCho);
        clearAndSendKeys(valorCho,"90");
        clickPerform(valorPtn);
        clearAndSendKeys(valorPtn,"1");
        clickPerform(valorLip);
        clearAndSendKeys(valorLip,"1");
        tempo();
        click(btnSalvar);
        tempo();
        click(btnOk);
        tempo();
        clickPerform(valorCho);
        clearAndSendKeys(valorCho,"50");
        clickPerform(valorPtn);
        clearAndSendKeys(valorPtn,"25");
        clickPerform(valorLip);
        clearAndSendKeys(valorLip,"25");
        tempo();
        click(btnSalvar);
        tempo();
    }

    public String retornaDesVet(){return getText(retornaValorDescricao);}
    public String retornaVlrCho(){return getText(retornaValorCho);}
    public String retornaVlrPtn(){return getText(retornaValorPtn);}
    public String retornaVlrLip(){return getText(retornaValorLip);}

    public String retornarDesVet(){return getText(retornarValorDescricao);}
    public String retornarVlrCho(){return getText(retornarValorCho);}
    public String retornarVlrPtn(){return getText(retornarValorPtn);}
    public String retornarVlrLip(){return getText(retornarValorLip);}

    public void editarAvaliacaoVet(){
        tempo();
        click(editarDescCalComp);
        clear(inserirNovaDesc);
        click(clicarVetCho);
        clearAndSendKeys(novoValorVetCho,"10");
        click(editarDescCalNutr);
        clearAndSendKeys(insereNovaDesc,"");
        click(clicaVetCho);
        clear(novoValVetCho);
        click(btnSalvarAlteracoes);
        tempo();
        click(btnOk);
        tempo();
        click(editarDescCalComp);
        clearAndSendKeys(inserirNovaDesc,"AUTOMAÇÃO");
        click(clicarVetCho);
        clearAndSendKeys(novoValorVetCho,"60");
        click(clicarVetPtn);
        clearAndSendKeys(novoValorVetPtn,"20");
        click(clicarVetLip);
        clearAndSendKeys(novoValorVetLip,"20");
        tempo();
        click(editarDescCalNutr);
        clearAndSendKeys(insereNovaDesc,"AUTOMAÇÃO");
        click(clicaVetCho);
        clearAndSendKeys(novoValVetCho,"40");
        click(clicaVetPtn);
        clearAndSendKeys(novoValVetPtn,"40");
        click(clicaVetLip);
        clearAndSendKeys(novoValVetLip,"20");
        tempo();
        click(btnSalvarAlteracoes);
        tempo();
    }

    public String retornaDescAtu(){return getText(retornaDescricaoAtu);}
    public String retornarDescAtu(){return getText(retornarDescricaoAtu);}
    public String vlrChoAtu(){return getText(valorChoAtu);}
    public String vlrPtnAtu(){return getText(valorPtnAtu);}
    public String vlrLipAtu(){return getText(valorLipAtu);}
    public String valChoAtu(){return getText(valChoAtu);}
    public String valPtnAtu(){return getText(valPtnAtu);}
    public String valLipAtu(){return getText(valLipAtu);}

    public void apagarAvaliacaoVet() {
        for (int i = 0; i < 2; i++) {
            tempo();
            click(btnExcluirAvaliacao);
            tempo();
            click(confirmaExclusao);
            tempo();
        }
    }

}
