package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.codehaus.plexus.util.StringUtils;
import org.openqa.selenium.By;
import org.testng.Assert;

public class ServicoXCicloPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaServicoXCiclo = By.xpath("//span[text() = 'Serviço x Ciclo']");
    By unidadeLogada = By.xpath("//div[@class=\"zh-header-info\"]");

    By campoCiclo = By.id("NMCARDCICLO");
    By cicloRetirada = By.xpath("//div[@data-zh-id=\"12687741182069372462464\"]//span[text() = '00001 | RETIRADA']");
    By cicloProducao = By.xpath("//div[@data-zh-id=\"12687741182069372462464\"]//span[text() = '00002 | PRODUÇÃO']");
    By cicloPreparo = By.xpath("//div[@data-zh-id=\"12687741182069372462464\"]//span[text() = '00003 | PREPARO']");

    By botaoAplicarFiltroInicial = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li");
    By botaoSelecionarMesInicial = By.xpath("//div[@class=\"dwbw dwb-s\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-ng-repeat=\"button in buttons\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");

    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoJabaquara = By.xpath("//div[@data-zh-id=\"12687741184110457951468\"]//span[text() = '0002 | DEPOSITO JABAQUARA']");
    By unidadeFarmacia = By.xpath("//div[@data-zh-id=\"12687741184110457951468\"]//span[text() = '0004 | FARMACIA BC 121']");
    By campoServico = By.id("NMSERVICO");
    By servicoJabaquaraAlmocoEspecial = By.xpath("//div[@data-zh-id=\"12687741182155474629472\"]//span[text() = '00002 | ALMOÇO ESPECIAL']");
    By servicoJabaquaraPalestra = By.xpath("//div[@data-zh-id=\"12687741182155474629472\"]//span[text() = '00010 | PALESTRA']");
    By servicoFarmaciaJanta = By.xpath("//div[@data-zh-id=\"12687741182155474629472\"]//span[text() = '00002 | JANTA']");
    By campoPadraoCiclo = By.id("NMPADCICLO");
    By padraoCicloVendas = By.xpath("//div[@data-zh-id=\"12687741182700974088475\"]//span[text() = '00001 | VENDAS']");
    By padraoCicloCompras = By.xpath("//div[@data-zh-id=\"12687741182700974088475\"]//span[text() = '00002 | COMPRAS']");
    By campoMesInicial = By.id("DTINICICLO");
    By inputMesInicial = By.xpath("//div[@id=\"DTINICICLO\"]//input");
    By mesAtual = By.xpath("//div[@aria-label=\"Mês\"]//div[@aria-selected=\"true\"]/div");
    By anoAtual = By.xpath("//div[@aria-label=\"Ano\"]//div[@aria-selected=\"true\"]/div");
    By campoNumeroCiclo = By.id("NRINICICLO");
    By numeroCiclo2030 = By.xpath("//div[@data-zh-id=\"12687741183758870695481\"]//span[text() = '3 | 01/2030']");
    By numeroCiclo2031 = By.xpath("//div[@data-zh-id=\"12687741183758870695481\"]//span[text() = '3 | 07/2031']");
    By numeroCiclo2033 = By.xpath("//div[@data-zh-id=\"12687741183758870695481\"]//span[text() = '4 | 06/2033']");

    By checkBoxServXCiclo1 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By unidadeServXCiclo1 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMFILIAL\"]/span");
    By servicoServXCiclo1 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMSERVICO\"]/span");
    By padraoCicloServXCiclo1 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPADCICLO\"]/span");
    By mesInicialServXCiclo1 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DTINICICLO_DISPLAY\"]/span");
    By numeroServXCiclo1 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRINICICLO\"]/span");

    By checkBoxServXCiclo2 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]//span[@data-ng-if=\"!row.__group\"]");
    By unidadeServXCiclo2 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMFILIAL\"]/span");
    By servicoServXCiclo2 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMSERVICO\"]/span");
    By padraoCicloServXCiclo2 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPADCICLO\"]/span");
    By mesInicialServXCiclo2 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"DTINICICLO_DISPLAY\"]/span");
    By numeroServXCiclo2 = By.xpath("//div[@id=\"grid-12687741182778308688447\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NRINICICLO\"]/span");

    By cicloHistorico1 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMCARDCICLO\"]/span");
    By padraoCicloHistorico1 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPADCICLO\"]/span");
    By mesInicialHistorico1 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"DTINICICLO\"]/span");
    By numeroCicloHistorico1 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NRCICLO\"]/span");

    By cicloHistorico2 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMCARDCICLO\"]/span");
    By padraoCicloHistorico2 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPADCICLO\"]/span");
    By mesInicialHistorico2 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"DTINICICLO\"]/span");
    By numeroCicloHistorico2 = By.xpath("//div[@id=\"grid-12687741182853774144448\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NRCICLO\"]/span");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");

    By mensagemObrigatorioCicloFiltroInicial = By.xpath("//div[@data-zh-id=\"12687741182069372462464\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"12687741184110457951468\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"12687741182155474629472\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPadraoCiclo = By.xpath("//div[@data-zh-id=\"12687741182700974088475\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioMesInicial = By.xpath("//div[@data-zh-id=\"1268774118335680171479\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioNumeroCiclo = By.xpath("//div[@data-zh-id=\"12687741183758870695481\"]//div[@class=\"zh-validation\"]/span");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Serviço x Ciclo");
        click(opcaoTelaServicoXCiclo);
    }

    public void preencherFiltroCicloProducao() {
        tempo();
        clicarCampoSelecionarValor(campoCiclo, cicloProducao);
        click(botaoAplicarFiltroInicial);
    }

    public void preencherFiltroCicloRetirada() {
        tempo();
        clicarCampoSelecionarValor(campoCiclo, cicloRetirada);
        click(botaoAplicarFiltroInicial);
    }

    public void preencherFiltroCicloDeposito() {
        clicarCampoSelecionarValor(campoCiclo, cicloPreparo);
        click(botaoAplicarFiltroInicial);
    }

    public void adicionarServicoPalestraJabaquara() {
        tempo();
        click(botaoAdicionar);
        tempo();
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
        tempo();
        clicarCampoSelecionarValor(campoServico, servicoJabaquaraPalestra);
        tempo();
        clicarCampoSelecionarValor(campoPadraoCiclo, padraoCicloVendas);
        selecionarMesAno(6, 2033);
        tempo();
        clicarCampoSelecionarValor(campoNumeroCiclo, numeroCiclo2033);
        click(botaoSalvar);
    }

    public void verificarSegundoRegistroComServDiferente() {
        tempo();
        tempo();
        String quantServXCiclos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-12687741182778308688447 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantServXCiclos, "2", "Verificar quantidade de registros no grid, após adicionar um segundo registro, com serviço diferente");

        tempo();
        String unidade1 = getText(unidadeServXCiclo1);
        String unidade2 = getText(unidadeServXCiclo2);
        String servico1 = getText(servicoServXCiclo1);
        String servico2 = getText(servicoServXCiclo2);

        Assert.assertEquals(unidade1, unidade2, "Verificar a unidade do primeiro serviço x ciclo, é igual a unidade do segundo serviço x ciclo");
        Assert.assertEquals(servico1.equals(servico2), false, "Verificar se o serviço do primeiro serviço x ciclo é diferente do serviço do segundo serviço x ciclo");

        click(unidadeServXCiclo1);
        tempo();
        String quantHistoricos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-12687741182853774144448 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantHistoricos, "1", "Verificar se após adicionar um segundo registro à mesma unidade, porém com serviços diferentes, o histórico continua com apenas 1 registro no primeiro serviço x ciclo");
        click(botaoVoltar);

        tempo();
        click(unidadeServXCiclo2);
        tempo();
        quantHistoricos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-12687741182853774144448 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantHistoricos, "1", "Verificar se após adicionar um segundo registro à mesma unidade, porém com serviços diferentes, o histórico continua com apenas 1 registro no segundo serviço x ciclo");
        click(botaoVoltar);
    }



    public void adicionarServicoXCiclo() {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoUnidade, unidadeFarmacia);
        clicarCampoSelecionarValor(campoServico, servicoFarmaciaJanta);
        clicarCampoSelecionarValor(campoPadraoCiclo, padraoCicloCompras);
        selecionarMesAno(1, 2030);
        tempo();
        clicarCampoSelecionarValor(campoNumeroCiclo, numeroCiclo2030);
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Registro adicionado com sucesso!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem de sucesso, após adicionar um serviço x ciclo");
    }

    public void verificarServicoXCicloAdd() {
        //valores esperados
        String expUnidade = "0004 - FARMACIA BC 121";
        String expServico = "00002 - JANTA";
        String expPadraoCiclo = "00002 - COMPRAS";
        String expMesInicial = "01/2030 - TER";
        String expNumeroCiclo = "3";

        //valores encontrados
        String encUnidade = getText(unidadeServXCiclo1);
        String encServico = getText(servicoServXCiclo1);
        String encPadraoCiclo = getText(padraoCicloServXCiclo1);
        String encMesInicial = getText(mesInicialServXCiclo1);
        String encNumeroCiclo = getText(numeroServXCiclo1);
        Assert.assertEquals(encUnidade, expUnidade, "Verificação unidade adicionada no servico x ciclo");
        Assert.assertEquals(encServico, expServico, "Verificação serviço adicionada no servico x ciclo");
        Assert.assertEquals(encPadraoCiclo, expPadraoCiclo, "Verificação padrão de ciclo adicionada no servico x ciclo");
        Assert.assertEquals(encMesInicial, expMesInicial, "Verificação mês inicial adicionada no servico x ciclo");
        Assert.assertEquals(encNumeroCiclo, expNumeroCiclo, "Verificação número do ciclo adicionada no servico x ciclo");

    }

    public void verificarHistoricoSerXCicloAdicionado() {
        click(unidadeServXCiclo1);
        //valores esperados
        String expCiclo = "PRODUÇÃO";
        String expPadraoCiclo = "COMPRAS - 00002";
        String expMesInicial = "01/2030 - TER";
        String expNumeroCiclo = "3";

        //valores encontrados
        String encCiclo = getText(cicloHistorico1);
        String encPadraoCiclo = getText(padraoCicloHistorico1);
        String encMesInicial = getText(mesInicialHistorico1);
        String encNumeroCiclo = getText(numeroCicloHistorico1);
        Assert.assertEquals(encCiclo, expCiclo, "Verificar do 'ciclo' no histórico do servico x ciclo adicionado");
        Assert.assertEquals(encPadraoCiclo, expPadraoCiclo, "Verificar do 'padrão de ciclo' no histórico do servico x ciclo adicionado");
        Assert.assertEquals(encMesInicial, expMesInicial, "Verificar do 'mês inicial' no histórico do servico x ciclo adicionado");
        Assert.assertEquals(encNumeroCiclo, expNumeroCiclo, "Verificar do 'número do ciclo' no histórico do servico x ciclo adicionado");

        click(botaoVoltar);
    }

    public void excluirServicoXCicloAdicionado() {
        click(checkBoxServXCiclo1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Remover registros selecionados?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida na tela após clicar para excluir o serviço x ciclo");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem de sucesso exibida no canto da tela após excluir o serviço x ciclo");
    }



    public void addSegundoServicoXCiclo() {
        tempo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
        clicarCampoSelecionarValor(campoServico, servicoJabaquaraAlmocoEspecial);
        clicarCampoSelecionarValor(campoPadraoCiclo, padraoCicloVendas);
        selecionarMesAno(7, 2031);
        tempo();
        clicarCampoSelecionarValor(campoNumeroCiclo, numeroCiclo2031);
        tempo();
        click(botaoSalvar);
    }

    public void verificarSegundoServicoXCiclo() {
        tempo();
        tempo();
        //valores esperados
        String expUnidade = "0002 - DEPOSITO JABAQUARA";
        String expServico = "00002 - ALMOÇO ESPECIAL";
        String expPadraoCiclo = "00001 - VENDAS";
        String expMesInicial = "07/2031 - TER";
        String expNumeroCiclo = "3";

        //valores encontrados
        String encUnidade = getText(unidadeServXCiclo2);
        String encServico = getText(servicoServXCiclo2);
        String encPadraoCiclo = getText(padraoCicloServXCiclo2);
        String encMesInicial = getText(mesInicialServXCiclo2);
        String encNumeroCiclo = getText(numeroServXCiclo2);
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da 'unidade' do segundo serviço x ciclo");
        Assert.assertEquals(encServico, expServico, "Verificação do 'serviço' do segundo serviço x ciclo");
        Assert.assertEquals(encPadraoCiclo, expPadraoCiclo, "Verificação do 'padrão de ciclo' do segundo serviço x ciclo");
        Assert.assertEquals(encMesInicial, expMesInicial, "Verificação do 'mês inicial' do segundo serviço x ciclo");
        Assert.assertEquals(encNumeroCiclo, expNumeroCiclo, "Verificação do 'número do ciclo' do segundo serviço x ciclo");
    }

    public void verificarDoisHistoricos() {
        click(unidadeServXCiclo1);
        tempo();
        String quantHistoricos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-12687741182853774144448 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantHistoricos, "2", "Verificar se após a exclusão o histórico possuí apenas 1 registro");


        //valores esperados para o primeiro histórico
        String expCiclo = "RETIRADA";
        String expPadraoCiclo = "VENDAS - 00001";
        String expMesInicial = "05/2027 - SÁB";
        String expNumeroCiclo = "7";

        //valores encontrados para o primeiro histórico
        String encCiclo = getText(cicloHistorico1);
        String encPadraoCiclo = getText(padraoCicloHistorico1);
        String encMesInicial = getText(mesInicialHistorico1);
        String encNumeroCiclo = getText(numeroCicloHistorico1);
        Assert.assertEquals(encCiclo, expCiclo, "Verificação 'ciclo' do primeiro histórico");
        Assert.assertEquals(encPadraoCiclo, expPadraoCiclo, "Verificação 'padrão de ciclo' do primeiro histórico");
        Assert.assertEquals(encMesInicial, expMesInicial, "Verificação 'mês inicial' do primeiro histórico");
        Assert.assertEquals(encNumeroCiclo, expNumeroCiclo, "Verificação 'número do ciclo' do primeiro histórico");

        //valores esperados para o segundo histórico
        expCiclo = "RETIRADA";
        expPadraoCiclo = "VENDAS - 00001";
        expMesInicial = "07/2031 - TER";
        expNumeroCiclo = "3";

        //valores encontrados para o segundo histórico
        encCiclo = getText(cicloHistorico2);
        encPadraoCiclo = getText(padraoCicloHistorico2);
        encMesInicial = getText(mesInicialHistorico2);
        encNumeroCiclo = getText(numeroCicloHistorico2);
        Assert.assertEquals(encCiclo, expCiclo, "Verificação 'ciclo' do segundo histórico");
        Assert.assertEquals(encPadraoCiclo, expPadraoCiclo, "Verificação 'padrão de ciclo' do segundo histórico");
        Assert.assertEquals(encMesInicial, expMesInicial, "Verificação 'mês inicial' do segundo histórico");
        Assert.assertEquals(encNumeroCiclo, expNumeroCiclo, "Verificação 'número do ciclo' do segundo histórico");

        click(botaoVoltar);
    }

    public void excluirSegundoServicoXCiclo() {
        click(checkBoxServXCiclo2);
        tempo();
        click(botaoExcluir);
        tempo();
        click(botaoSim);

        tempo();
        tempo();
        click(unidadeServXCiclo1);
        tempo();
        String quantHistoricos = javaScriptExecutor.executeScript("return document.querySelector(\"#grid-12687741182853774144448 > div.body > div\").childElementCount").toString();
        Assert.assertEquals(quantHistoricos, "1", "Verificar se após a exclusão o histórico possuí apenas 1 registro");
    }

    public void tentarAdicionarRegistroJaCadastrado() {
        adicionarServicoXCiclo();
        click(botaoAdicionar);
        clicarCampoSelecionarValor(campoUnidade, unidadeFarmacia);
        clicarCampoSelecionarValor(campoServico, servicoFarmaciaJanta);
        clicarCampoSelecionarValor(campoPadraoCiclo, padraoCicloCompras);
        selecionarMesAno(1, 2030);
        tempo();
        clicarCampoSelecionarValor(campoNumeroCiclo, numeroCiclo2030);
        click(botaoSalvar);
        tempo();

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Mês inicial já cadastrado para o ciclo: 00003.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um registro que já existe");
        click(botaoOk);
        tempo();
        click(botaoCancelar);
        tempo();
        excluirServicoXCicloAdicionado();
    }



    public void camposHabilitadosAddServXCiclo() {
        tempo();
        click(botaoAdicionar);
        tempo();

        boolean unidade = !javaScriptExecutor.executeScript("return document.querySelector(\"#NMFILIAL\").className").toString().contains("zh-disabled");
        boolean servico = !javaScriptExecutor.executeScript("return document.querySelector(\"#NMSERVICO\").className").toString().contains("zh-disabled");
        boolean padraoCiclo = !javaScriptExecutor.executeScript("return document.querySelector(\"#NMPADCICLO\").className").toString().contains("zh-disabled");
        boolean mesInicial = !javaScriptExecutor.executeScript("return document.querySelector(\"#DTINICICLO\").className").toString().contains("zh-disabled");
        boolean numeroCiclo = !javaScriptExecutor.executeScript("return document.querySelector(\"#NRINICICLO\").className").toString().contains("zh-disabled");
        Assert.assertEquals(unidade, true, "Verificar se no formulário para adicionar um serviço x ciclo, o campo 'unidade' está habilitado");
        Assert.assertEquals(servico, false, "Verificar se no formulário para adicionar um serviço x ciclo, o campo 'serviço' está habilitado");
        Assert.assertEquals(padraoCiclo, true, "Verificar se no formulário para adicionar um serviço x ciclo, o campo 'padrão de ciclo' está habilitado");
        Assert.assertEquals(mesInicial, true, "Verificar se no formulário para adicionar um serviço x ciclo, o campo 'mês inicial' está habilitado");
        Assert.assertEquals(numeroCiclo, false, "Verificar se no formulário para adicionar um serviço x ciclo, o campo 'número de ciclo' está habilitado");

        clicarCampoSelecionarValor(campoUnidade, unidadeDepositoJabaquara);
        servico = !javaScriptExecutor.executeScript("return document.querySelector(\"#NMSERVICO\").className").toString().contains("zh-disabled");
        Assert.assertEquals(servico, true, "Verificar se ao selecionar uma unidade o campo serviço passa a estar habilitado");

        selecionarMesAno(10, 2030);
        numeroCiclo = !javaScriptExecutor.executeScript("return document.querySelector(\"#NRINICICLO\").className").toString().contains("zh-disabled");
        Assert.assertEquals(numeroCiclo, true, "Verificar se após selecionar o mês inicial, o campo número do ciclo passa a estar habilitado");
    }

    public void campoObrigatorioCiclo() {
        click(botaoAplicarFiltroInicial);

        String ciclo = getText(mensagemObrigatorioCicloFiltroInicial);
        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(ciclo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo ciclo");
    }

    public void camposObrigatoriosAddServXCiclo() {
        tempo();
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String padraoCiclo = getText(mensagemObrigatorioPadraoCiclo);
        String mesInicial = getText(mensagemObrigatorioMesInicial);
        String numeroCiclo = getText(mensagemObrigatorioNumeroCiclo);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade', no formulário para adicionar um serviço x ciclo");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'serviço', no formulário para adicionar um serviço x ciclo");
        Assert.assertEquals(padraoCiclo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'padrão de ciclo', no formulário para adicionar um serviço x ciclo");
        Assert.assertEquals(mesInicial, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'mês inicial', no formulário para adicionar um serviço x ciclo");
        Assert.assertEquals(numeroCiclo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'número de ciclo', no formulário para adicionar um serviço x ciclo");
        click(botaoCancelar);
    }

    public void validarDataProcessamento() {
        String dataProcessamento = "01" + getText(unidadeLogada).substring(2, 10);

        int mesData = Integer.parseInt(getText(unidadeLogada).substring(3, 5));
        int anoData = Integer.parseInt(getText(unidadeLogada).substring(6, 10));
        int mes = 0;
        int ano = 0;
        if (mesData == 1) {
            mes = mesData;
            ano = anoData - 1;
        } else {
            mes = mesData - 1;
            ano = anoData;
        }

        tempo();
        tempo();
        click(botaoAdicionar);
        selecionarMesAno(mes, ano);
        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "A data de início não pode ser menor que a data de processamento (" + dataProcessamento + ") da unidade!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação mensagem exibida quando o mês inicial selecionado é menor que a data de processamento da unidade");

        click(botaoOk);
        String dataCampoMesInicial = getValue(inputMesInicial);
        Assert.assertEquals(dataCampoMesInicial, "", "Verificar se após selecionar uma data menor que a data de processamente e clicar em ok, o campo mês inicial fica vazio");

        selecionarMesAno(mesData, anoData);
        dataCampoMesInicial = getValue(inputMesInicial);
        String mesInicialExp = "0" + mesData + "/" + anoData;
        Assert.assertEquals(dataCampoMesInicial, mesInicialExp, "Verificar se após selecionar uma data com mês e ano iguais a data de processamente, o campo mês inicial apresenta o mês e ano selecionados");
        click(botaoCancelar);
    }


    private void selecionarMesAno(int mesParaSelecionar, int anoParaSelecionar) {
        click(campoMesInicial);
        tempo();
        //selecionar mês
        int mes = Integer.parseInt(getText(mesAtual));
        if (mes != mesParaSelecionar) {

            if (mes > mesParaSelecionar) {
                mes = mes - 1;
                //o mês atual é maior que o mês para selecionar
                for (int x = mes; x >= mesParaSelecionar; x--) {
                    //caso o mês seja menor que 10, ele terá apenas 1 número. O método abaixo acrescentará um 0 a esquerda para que seja possivel mapear o número na tela
                    String codMes = StringUtils.leftPad(String.valueOf(x), 2, "0");
                    By clickMes = By.xpath("//div[@aria-label=\"Mês\"]//div[text() = '" + codMes + "']");
                    click(clickMes);
                }
            }

            else {
                mes = mes + 1;
                //o mês atual é menor que o mês para selecionar
                for (int x = mes; x <= mesParaSelecionar; x++) {
                    //caso o mês seja menor que 10, ele terá apenas 1 número. O método abaixo acrescentará um 0 a esquerda para que seja possivel mapear o número na tela
                    String codMes = StringUtils.leftPad(String.valueOf(x), 2, "0");
                    By clickMes = By.xpath("//div[@aria-label=\"Mês\"]//div[text() = '" + codMes + "']");
                    click(clickMes);
                }
            }

        }

        //selecionar ano
        int ano = Integer.parseInt(getText(anoAtual));
        if (ano != anoParaSelecionar) {

            if (ano > anoParaSelecionar) {
                ano = ano - 1;
                for (int codAno = ano; codAno >= anoParaSelecionar; codAno--) {
                    By clickAno = By.xpath("//div[@aria-label=\"Ano\"]//div[text() = '" + codAno + "']");
                    click(clickAno);
                }
            }

            else  {
                ano = ano + 1;
                for (int codAno = ano; codAno <= anoParaSelecionar; codAno++) {
                    By clickAno = By.xpath("//div[@aria-label=\"Ano\"]//div[text() = '" + codAno + "']");
                    click(clickAno);
                }
            }
        }

        click(botaoSelecionarMesInicial);
    }


}
