package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.AcompanhamentoAprovCardFlows;
import com.javaseleniumtemplate.pages.AcompanhamentoAprovCardPage;
import org.testng.annotations.Test;

public class  AcompanhamentoAprovCardTests extends TestBase {

    AcompanhamentoAprovCardPage acompanhamentoAprovCardPage;
    AcompanhamentoAprovCardFlows acompanhamentoAprovCardFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Acompanhamento de Aprovação de Cardápio'
    //clicar no campo relatório e selecionar o relatório 'Acompanhamento de Aprovação de Cardápio'
    //clicar no campo unidade, selecionar duas unidades, clicar no botão ok
    //clicar no check-box 'todos' serviços, clicar no campo serviço, selecionar 3 serviços, clicar no botão ok
    //clicar no 'cardápio de' e selecionar o mês 03/2023, clicar no campo 'até' e selecionar o mês 10/2023
    //clicar no botão relatório, clicar em pdf, clicar para gerar o relatório, fechar a guia do relatório
    //clicar no check-box 'todas' unidades, clicar no check-box 'todos' serviços
    //clicar no botão relatório, clicar em pdf, clicar para gerar o relatório, fechar a guia do relatório
    @Test
    public void gerarRelatorios() {
        acompanhamentoAprovCardPage = new AcompanhamentoAprovCardPage();
        acompanhamentoAprovCardFlows = new AcompanhamentoAprovCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoAprovCardFlows.navegateAcompAprovCard();
        acompanhamentoAprovCardPage.selecionarRelatorio();
        acompanhamentoAprovCardPage.selecionarUnidades();
        acompanhamentoAprovCardPage.selecionarServicos();
        acompanhamentoAprovCardPage.selecionarMeses();
        acompanhamentoAprovCardPage.geraRelatorio();
        acompanhamentoAprovCardPage.selecionarTodasUnidadesEServicos();
        acompanhamentoAprovCardPage.geraRelatorio();
    }


    //acessar a tela 'Acompanhamento de Aprovação de Cardápio'
    //clicar no 'cardápio de' e selecionar o mês 03/2023, clicar no campo 'até' e selecionar o mês 10/2023
    @Test
    public void selecionarMeses() {
        acompanhamentoAprovCardPage = new AcompanhamentoAprovCardPage();
        acompanhamentoAprovCardFlows = new AcompanhamentoAprovCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoAprovCardFlows.navegateAcompAprovCard();
        acompanhamentoAprovCardPage.selecionarMeses();
    }


    //acessar a tela 'Acompanhamento de Aprovação de Cardápio'
    //verificar se o check-box 'todas' unidades não está selecionado e dessa forma o campo unidade está habilitado
    //verificar se o check-box 'todos' serviços está selecionado e dessa forma o campo serviço está desabilitado
    //clicar no check-box 'todas' unidades e verificar se o mesmo passa a estar selecionado e o campo unidade passa a estar desabilitado
    //clicar no check-box 'todos' serviços e verificar se o mesma passa a não estar mais selecionado e o campo serviço passa a estar selecionado
    @Test
    public void interacaoCheckBoxUnidadeServico() {
        acompanhamentoAprovCardPage = new AcompanhamentoAprovCardPage();
        acompanhamentoAprovCardFlows = new AcompanhamentoAprovCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoAprovCardFlows.navegateAcompAprovCard();
        acompanhamentoAprovCardPage.interacaoCheckBox();
    }


    //acessar a tela 'Acompanhamento de Aprovação de Cardápio'
    //clicar no campo 'cardápio de' e selecionar o mês de Outubro
    //clicar no campo 'até' e selecionar o mês de Março
    //clicar no botão relatório
    //verificar a mensagem exibida na tela informando que o campo 'cardápio de' deve ser menor ou igual ao campo 'até'
    //clicar em ok
    @Test
    public void mesesInvalidos() {
        acompanhamentoAprovCardPage = new AcompanhamentoAprovCardPage();
        acompanhamentoAprovCardFlows = new AcompanhamentoAprovCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoAprovCardFlows.navegateAcompAprovCard();
        acompanhamentoAprovCardPage.mesFinalMaiorQueInicial();
    }


    //acessar a tela 'Acompanhamento de Aprovação de Cardápio'
    //clicar no check-box 'todos' serviços, clicar no botão do campo 'cardápio de', clicar no botão do campo 'até', clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: unidade, serviço, cardápio de, cardápio até
    @Test
    public void camposObrigatorios() {
        acompanhamentoAprovCardPage = new AcompanhamentoAprovCardPage();
        acompanhamentoAprovCardFlows = new AcompanhamentoAprovCardFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        acompanhamentoAprovCardFlows.navegateAcompAprovCard();
        acompanhamentoAprovCardPage.camposObrigatorios();
    }

}
