package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.GrupoNutrientesFlows;
import com.javaseleniumtemplate.pages.GrupoNutrientesPage;
import org.testng.annotations.Test;

public class GrupoNutrientesTests extends TestBase {

    GrupoNutrientesPage grupoNutrientesPage;
    GrupoNutrientesFlows grupoNutrientesFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Grupo de Nutrientes'
    //clicar no botão adicionar, preencher os campos código e nome, clicar no botão salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //no filtro da tela, procurar por 20
    //verificar se o código e o nome do grupo foram salvos corretamente
    //clicar no check-box do grupo encontrado, clicar no botão excluir
    //verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar a mensagem exibida no grid da lista de grupos, informando que nenhum registro foi encontrado
    @Test
    public void adicionarExcluirGrupo() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.adicionarGrupo();
        grupoNutrientesPage.excluirGrupo();
    }


    //acessar a tela 'Grupo de Nutrientes'
    //no filtro da tela, procurar por 06
    //alterar o nome do grupo e clicar em 'Salvar alterações'
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //atualizar a página, procurar novamente por 06 e verificar se o nome do grupo foi salvo corretamente
    //alterar o nome do grupo, retornando para o nome que estava no início do teste e verificar se o nome foi alterado corretamente
    @Test
    public void editarNomeGrupoNutrientes() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.editarGrupo();
    }


    //acessar a tela 'Grupo de Nutrientes'
    //clicar no botão adicionar, tentar adicionar um grupo com o código 1, clicar no botão salvar
    //verificar a mensagem exibida na tela informando que o código já existe, clicar no botão ok e clicar em cancelar
    @Test
    public void tentarAdicionarCodigoExistente() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.tentarAdicionarCodigoExistente();
    }


    //acessar a tela 'Grupo de Nutrientes'
    //no filtro da tela procurar por 02
    //clicar no código do grupo, clicar na aba nutrientes
    //clicar no botão adicionar, selecionar os nutrientes VITAMINA A e VITAMINA E, clicar no botão adicionar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se os dados(código, nome e sigla) do nutriente da primeira linha correspondem aos dados da VITAMINA A
    //verificar se os dados(código, nome e sigla) do nutriente da primeira linha correspondem aos dados da VITAMINA E
    //selecionar o check-box dos nutrientes da primeira e segunda linha
    //clicar em excluir, verificar a mensagem exibida na tela e clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar se no grid da lista de nutrientes é informando que não há registros
    //clicar em voltar
    @Test
    public void adicionarExcluirNutrientes() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.adicionarNutrientes();
        grupoNutrientesPage.excluirNutrientes();
    }


    //acessar a tela 'Grupo de Nutrientes'
    //no filtro da tela, procurar por 01
    //clicar no check-box do grupo, clicar em excluir
    //verificar a mensagem exibida na tela e clicar em sim
    //verificar a mensagem exibida na tela informando que a exclusão na é permitida, por conta de o grupo possuir registros filhos
    //clicar em ok e clicar no código do grupo, para verificar se o grupo não foi excluído
    @Test
    public void tentarExcluirGrupoComRegistrosFilhos() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.tentarExcluirGrupoComRegistrosFilhos();
    }


    //acessar a tela 'Grupo de Nutrientes'
    //clicar no botão relatório, clicar no campo relatório e selecionar o relatório 'Grupo de Nutriente'
    //verificar se o 'Todos' do grupos de nutrientes já vem selecionado ao carregar a tela
    //clicar na opção 'Todos' do grupos de nutrientes e verificar se o mesmo passa a estar selecionar
    //clicar no 'Todos' do grupos de nutrientes, para que o campo do grupos de nutrientes fique habilitado
    //clicar no campo do grupos de nutrientes e selecionar os nutrientes CARBOIDRATOS e PROTEÍNAS
    //clicar em ok e verificar se os grupos selecionados aparecem no campo de grupos de nutrientes
    //clicar no botão gerar relatório, clicar no tipo pdf e clicar em confirmar
    //fechar a aba em que é aberta o relatório
    @Test
    public void gerarRelatorio() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.gerarRelatorio();
    }


    //acessar a tela 'Grupo de Nutrientes'
    //clicar no botão adicionar, clicar em salvar e verificar se aparece a mensagem de campo obrigatório nos campos: código e nome
    //clicar em cancelar, clicar em relatório, clicar em gerar relatório
    //verificar se é apresentada a mensagem de campo obrigatório no campo: grupos de nutrientes
    @Test
    public void camposObrigatorios() {
        grupoNutrientesPage = new GrupoNutrientesPage();
        grupoNutrientesFlows = new GrupoNutrientesFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        grupoNutrientesFlows.navegateTelaGrupoNutrientes();
        grupoNutrientesPage.camposObrigatoriosAdicionarGrupo();
        grupoNutrientesPage.campoObrigatorioRelatorio();
    }

}
