package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PadraoCicloFlows;
import com.javaseleniumtemplate.pages.PadraoCicloPage;
import org.testng.annotations.Test;

public class PadraoCicloTests extends TestBase {

    PadraoCicloPage padraoCicloPage;
    PadraoCicloFlows padraoCicloFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Padrão de Ciclo'
    //clicar no botão adicionar, preencher os campos código, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //procurar na tela inicial pelo código do padrão de ciclo adicionado
    //verificar se o código e nome foram salvos corretamente
    //procurar na tela inicial pelo código do padrão de ciclo adicionado
    //clicar no check-box do padrão de ciclo, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar no grid da lista de padrões de ciclo, a mensagem de que nenhum registro foi encontrado
    @Test
    public void adicionarExcluirPadraoCiclo() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.adicionarPadrao();
        padraoCicloPage.verificarPadraoCicloAdd();
        padraoCicloPage.excluirPadraoCiclo();
    }


    //acessar a tela 'Padrão de Ciclo'
    //procurar na tela inicial pelo código do padrão de ciclo 00002
    //clicar no campo nome, alterar o valor para PREPARAÇÃO, clicar em salvar
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar o nome alterado foi salvo corretamente
    //atualizar a página, procurado no filtro inicial da tela pelo código 00002
    //clicar no campo nome, alterar o valor para COMPRAS, retornando para o valor que estava no início do teste, clicar em salvar
    //verificar se o nome foi salvo corretamente
    @Test
    public void editarPadraoCiclo() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.editarPadraoCiclo();
    }


    //acessar a tela 'Padrão de Ciclo'
    //clicar no botão adicionar, clicar em salvar
    //verificar a mensagem de campo obrigatório nos campos: código e nome
    //clicar em cancelar
    @Test
    public void camposObrigatorios() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.camposObrigatorios();
    }


    //acessar a tela 'Padrão de Ciclo'
    //clicar no botão adicionar, preencher o campo código com o valor 1, preencher o campo nome, clicar em salvar
    //verificar a mensagem exibida na tela informando que o código já existe
    //clicar em ok, clicar em cancelar
    @Test
    public void tentarAddPadraoComCodigoExistente() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.tentarAddPadraoComCodigoExistente();
    }


    //acessar a tela 'Padrão de Ciclo'
    //procurar na tela inicial pelo código do padrão de ciclo 00001
    //clicar no check-box do padrão de ciclo, clicar no botão excluir
    //clicar no botão sim, verificar a mensagem exibida na tela informando que a exclusão não é permitida, pois possui registros filhos
    //clicar no botão ok, clicar no check-box do padrão de ciclo
    @Test
    public void tentarExcluirPadraoComRegFilho() {
        padraoCicloPage = new PadraoCicloPage();
        padraoCicloFlows = new PadraoCicloFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        padraoCicloFlows.navegatePadraoCiclo();
        padraoCicloPage.tentarExcluirPadraoComRegFilho();
    }



}
