package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.PadraoDeGrupoDePratoFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class PadraoDeGrupoDePratoTests extends TestBase {

    LoginFlows loginFlows;
    PadraoDeGrupoDePratoFlows padraoDeGrupoDePratoFlows;


    public void acessarTela(String NMTIPO){
        loginFlows = new LoginFlows();
        padraoDeGrupoDePratoFlows = new PadraoDeGrupoDePratoFlows();
        String NMTELA = "Padrão de Grupo de Prato";

        loginFlows.efetuarLogin();
        padraoDeGrupoDePratoFlows.acessarTela();
        Assert.assertEquals(padraoDeGrupoDePratoFlows.retornaTelaAcessada(),NMTELA,"Falha ao acessar tela: ");
        padraoDeGrupoDePratoFlows.realizarFiltro(NMTIPO);
    }

    public void validarCamposObrigatorios(){padraoDeGrupoDePratoFlows.validarCamposObrigatorios();}

    public void realizarCadastroPadraoGrupoPrato(){
        String NMGRUP_2 = "0000000002";
        String NMGRUP_3 = "0000000003";
        String NMGRUP_4 = "0000000004";
        padraoDeGrupoDePratoFlows.realizaCadastro();
        Assert.assertEquals(padraoDeGrupoDePratoFlows.validaCadastroGrupo_2(),NMGRUP_2,"Cadastro grupo dois :");
        Assert.assertEquals(padraoDeGrupoDePratoFlows.validaCadastroGrupo_3(),NMGRUP_3,"Cadastro grupo três :");
        Assert.assertEquals(padraoDeGrupoDePratoFlows.validaCadastroGrupo_4(),NMGRUP_4,"Cadastro grupo quatro :");
    }

    public void editarNomesPadraoGrupoPrato(){
        String NMGRUPO_2 = "LANCHE NOITE";
        String NMGRUPO_3 = "REFEIÇÃO";
        String NMGRUPO_4 = "LANCHE TARDE";

        padraoDeGrupoDePratoFlows.editarGrupoPrato();
        Assert.assertEquals(padraoDeGrupoDePratoFlows.validaAlteracaoGrupo_2(),NMGRUPO_2,"Alteração do grupo dois :");
        Assert.assertEquals(padraoDeGrupoDePratoFlows.validaAlteracaoGrupo_3(),NMGRUPO_3,"Alteração do grupo três :");
        Assert.assertEquals(padraoDeGrupoDePratoFlows.validaAlteracaoGrupo_4(),NMGRUPO_4,"Alteração do grupo quatro :");

    }

    public void excluirPadraoGrupoPrato(){
        String MSGESPERADA = "Excluído com sucesso.";
        padraoDeGrupoDePratoFlows.excluirPadraoGrupoPrato();
        Assert.assertEquals(padraoDeGrupoDePratoFlows.mensagemExclusao(),MSGESPERADA,"Exclusão registros padrão de grupo de prato: ");
    }

    @Test
    public void cadastroPadraoGrupoPratoContrato(){
        String NMTIPO = "Contrato";
        acessarTela(NMTIPO);
        validarCamposObrigatorios();
        realizarCadastroPadraoGrupoPrato();
    }

    @Test
    public void editarPadraoGrupoPratoContrato(){
        String NMTIPO = "Contrato";
        acessarTela(NMTIPO);
        editarNomesPadraoGrupoPrato();
    }

    @Test
    public void excluirPadraoGrupoPratoContrato(){
        String NMTIPO = "Contrato";
        acessarTela(NMTIPO);
        excluirPadraoGrupoPrato();

    }

    @Test
    public void cadastroPadraoGrupoPratoPlanejado(){
        String NMTIPO = "Planejado";
        acessarTela(NMTIPO);
        validarCamposObrigatorios();
        realizarCadastroPadraoGrupoPrato();
    }

    @Test
    public void editarPadraoGrupoPratoPlanejado(){
        String NMTIPO = "Planejado";
        acessarTela(NMTIPO);
        editarNomesPadraoGrupoPrato();
    }

    @Test
    public void excluirPadraoGrupoPratoPlanejado(){
        String NMTIPO = "Planejado";
        acessarTela(NMTIPO);
        excluirPadraoGrupoPrato();

    }

}
