package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RelacaoCardapiosFlows;
import com.javaseleniumtemplate.pages.RelacaoCardapiosPage;
import org.testng.annotations.Test;

public class RelacaoCardapiosTests extends TestBase {

    RelacaoCardapiosPage relacaoCardapiosPage;
    RelacaoCardapiosFlows relacaoCardapiosFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioSinteticaPorData() {
        emitiRelatorio("Relação de Cardápios (Sintética por Data)");
    }

    @Test
    public void relatorioSinteticaPorServico() {
        emitiRelatorio("Relação de Cardápios (Sintética por Serviço)");
    }

    @Test
    public void relatorioElaboradosPorServico() {
        emitiRelatorio("Relação de Cardápios Elaborados por Serviço");
    }

    @Test
    public void relatorioAnaliticaPorData() {
        emitiRelatorio("Relação de Cardápios (Analítica por Data)");
    }

    @Test
    public void relatorioAnaliticaPorServico() {
        emitiRelatorio("Relação de Cardápios (Analítica por Serviço)");
    }

    @Test
    public void relatorioGeradosAnalitico() {
        emitiRelatorio("Relação de Cenários Gerados por serviço (Analítico)");
    }

    @Test
    public void relatorioGeradosSintetico() {
        emitiRelatorio("Relação de Cenários Gerados por serviço (Sintético)");
    }


    //acessar a tela 'Relação de Cardápios'
    //selecionar o relatório que é passado como parâmetro
    //clicar no check-box 'Todos' unidade, preencher a data inicial e final
    //clicar no botão relatório, tipo pdf, clicar em confirmar, fechar a guia em que o relatório foi aberto
    //clicar no check-box 'Todos' unidade, clicar no campo unidade, selecionar a unidade Deposito BC 129, clicar em ok
    //clicar no check-box 'Todos' serviço, clicar no campo serviço, selecionar os serviços 'Solicitação' e 'Distribuição', clicar em ok
    //clicar no botão relatório, tipo pdf, clicar em confirmar, fechar a guia em que o relatório foi aberto
    public void emitiRelatorio(String nomeDoRelatorio) {
        relacaoCardapiosPage = new RelacaoCardapiosPage();
        relacaoCardapiosFlows = new RelacaoCardapiosFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/08/2022";
        String dataFinal = "31/10/2022";

        loginFlows.efetuarLogin();
        relacaoCardapiosFlows.navegateRelacaoCardapios();
        relacaoCardapiosPage.selecionaRelatorio(nomeDoRelatorio);
        relacaoCardapiosPage.selecionarTodasUnidades();
        relacaoCardapiosPage.preencherDatas(dataInicial, dataFinal);
        relacaoCardapiosPage.geraRelatorio();
        relacaoCardapiosPage.selecionarUnidade();
        relacaoCardapiosPage.selecionarServicos();
        relacaoCardapiosPage.geraRelatorio();
    }






    //acessar a tela 'Relação de Cardápios'
    //selecionar um relatório, clicar no check-box 'todos' os serviços, clicar no botão relatório
    //verificar a mensagem de campo obrigatório nos campos: unidade, serviço e data
    //verificar se por padrão o check-box do campo 'Somente Serviço Principal' já vem selecionado
    //clicar no check-box do campo 'Somente Serviço Principal' e verificar se o mesmo passa a não estar mais selecionado
    //atualizar a página e refazer todo processo com todos os relatórios
    @Test
    public void verificarCamposObrigatorios() {
        relacaoCardapiosPage = new RelacaoCardapiosPage();
        relacaoCardapiosFlows = new RelacaoCardapiosFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoCardapiosFlows.navegateRelacaoCardapios();
        relacaoCardapiosPage.verificarCamposObrigatorios();
    }



}
