package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RelacaoPratoXEmbalagemFlows;
import com.javaseleniumtemplate.pages.RelacaoPratoXEmbalagemPage;
import org.testng.annotations.Test;

public class RelacaoPratoXEmbalagemTests extends TestBase {

    RelacaoPratoXEmbalagemPage relacaoPratoXEmbalagemPage;
    RelacaoPratoXEmbalagemFlows relacaoPratoXEmbalagemFlows;
    LoginFlows loginFlows;


    //acessar a tela 'Relação Prato x Embalagem'
    //clicar no prato FEIJOADA TRANSPORTADA, clicar no botão adicionar, clicar no botão do campo embalagem, selecionar a embalagem PANELA, inserir a quantidade
    //clicar no botão 'salvar e próximo', verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela, clicar em cancelar
    //verificar se o código, nome e quantidade da embalagem, foram adicionados corretamente no prato FEIJOADA TRANSPORTADA
    //clicar no botão voltar, clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem PANELA, clicar na embalagem da primeira linha encontrada pelo filtro
    //verificar se o código, nome, unidade e quantidade do prato FEIJOADA TRANSPORTADA foram adicionados corretamente na embalagem PANELA
    //clicar no check-box do prato, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar no grid da lista de pratos da embalagem se após a exclusão do prato é apresentada a mensagem de 'não há registros'
    //clicar no botão voltar, clicar na aba 'Embalagem por Prato', clicar no prato FEIJOADA TRANSPORTADA
    //verificar no grid da lista de embalagens do prato se após a exclusão do prato na embalagem é apresentada a mensagem de 'não há registros'
    @Test
    public void teste01() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.adicionarEmbalagemPrato();
        relacaoPratoXEmbalagemPage.verificarEmbalagemAdicionadaPeloPrato();
        relacaoPratoXEmbalagemPage.excluirPratoAbaPratoEmbalagem();
    }


    //acessar a tela 'Relação Prato x Embalagem'
    //clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem PLÁSTICO, clicar na primeira embalagem encontrada pelo filtro
    //clicar no botão adicionar, clicar no botão do campo prato, selecionar o prato TORTA DE CHOCOLATE, inserir a quantidade, clicar no botão 'salvar e próximo'
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se o código, nome, unidade e quantidade do prato, foram adicionados corretamente na embalagem
    //clicar no botão voltar, clicar na aba 'Embalagem por Prato', no filtro procurar pelo prato TORTA DE CHOCOLATE, clicar no prato TORTA DE CHOCOLATE
    //verificar se o código, nome e quantidade da embalagem PLÁSTICO, foram adicionados corretamente ao prato TORTA DE CHOCOLATE
    //clicar no check-box da embalagem, clicar em excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar no grid da lista de embalagens do prato, após a exclusão da embalagem, é apresenta a mensagem de 'não há registros'
    //clicar em voltar, clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem MADEIRA, clicar na primeira embalagem encontrada pelo filtro
    //verificar no grid da lista de pratos da embalagem, após a exclusão da embalagem no prato, é apresentada a mensagem de 'não há registros'
    @Test
    public void teste02() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.adicionarPratoEmbalagem();
        relacaoPratoXEmbalagemPage.verificarPratoAdicionadoNaEmbalagem();
        relacaoPratoXEmbalagemPage.excluirEmbalagemAbaEmbalagemPrato();
    }


    //acessar a tela 'Relação Prato x Embalagem'
    //passar por parâmetro a nova quantidade da embalagem
    //clicar na aba 'Embalagem por Prato', clicar no prato PAVÊ DE MARACUJÁ, alterar a quantidade da embalagem POTE DESCARTÁVEL para o valor que foi passado como parâmetro
    //clicar em 'salvar alterações', verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se a nova quantidade da embalagem foi salva corretamente no prato PAVÊ DE MARACUJÁ
    //clicar no botão voltar, clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem POTE DESCARTÁVEL
    //clicar na primeira embalagem encontrada pelo filtro
    //verificar se a quantidade do prato na embalagem POTE DESCARTÁVEL, também foi alterada para o valor passada como parâmetro, clicar em voltar
    //passar um novo valor da quantidade de embalagem, e refazer o processo de alterar a quantidade na tela de prato, conferir se foi salvo corretamente
    //acessar a embalagem e verificar se o valor da quantidade também foi alterada corretamente
    @Test
    public void teste03() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        String quantidadeInicialTeste = "7,00000";
        String quantidadeAlterada = "8,30000";

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.editarQuantidadeEmbalagemPrato(quantidadeAlterada);
        relacaoPratoXEmbalagemPage.editarQuantidadeEmbalagemPrato(quantidadeInicialTeste);
    }


    //acessar a tela 'Relação Prato x Embalagem'
    //passar por parâmetro a nova quantidade para o prato
    //clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem VIDRO, clicar na primeira embalagem encontrada pelo filtro
    //alterar a quantidade do prato, para o valor que foi passado como parâmetro, clicar em 'salvar alterações'
    //verificar a mensagem de salvo com sucesso exibida no canto superior direito da tela
    //verificar se a nova quantidade do prato foi alterada corretamente na embalagem VIDRO
    //clicar no botão voltar, clicar na aba 'Embalagem por Prato', clicar no prato PAVÊ DE ABACAXI COM COCO
    //verificar se a quantidade da embalagem foi alterada corretamente para o valor que foi passado como parâmetro
    //passar um novo valor para a quantidade do prato, refazer o processo de alterar a quantidade do prato na embalagem, verificar se foi salvo corretamente
    //acessar o prato e verificar se a quantidade da embalagem também foi alterada corretamente
    @Test
    public void teste04() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        String quantInicioTeste = "6,10000";
        String quantAlteracao = "4,50000";

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.editarQuantidadePratoEmb(quantInicioTeste);
        relacaoPratoXEmbalagemPage.editarQuantidadePratoEmb(quantAlteracao);
    }


    //acessar a tela 'Relação Prato x Embalagem'
    //clicar no prato ARROZ BRANCO, clicar no botão adicionar, clicar no botão 'salvar e próximo'
    //verificar a mensagem de campo obrigatório nos campos: embalagem e quantidade
    //verificar a mensagem de valor mínimo do campo quantidade
    //clicar em cancelar, clicar no botão voltar, clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem MADEIRA,
    //clicar na primeira embalagem encontrada pelo filtro
    //clicar no botão adicionar, clicar no botão 'salvar e próximo'
    //verificar a mensagem de campo obrigatório nos campos: prato e quantidade
    //verificar a mensagem de valor mínimo do campo quantidade
    //clicar em cancelar, clicar no botão voltar
    @Test
    public void teste05() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.camposObrigatoriosAddEmbalagem();
        relacaoPratoXEmbalagemPage.camposObrigatoriosAddPrato();
    }


    //acessar a tela 'Relação Prato x Embalagem'
    //clicar no prato PÃO DE QUEIJO, clicar no botão adicionar, clicar no botão do campo embalagem, selecionar a embalagem MARMITÉX, inserir a quantidade
    //clicar em 'salvar e próximo', verificar a mensagem exibida na tela informando que é impossível adicionar, pois o registro já existe
    //clicar em ok, clicar em cancelar, clicar em voltar
    //clicar na aba 'Prato por Embalagem', no filtro procurar pela embalagem MARMITÉX, clicar na primeira embalagem encontrada pelo filtro
    //clicar no botão adicionar, clicar no botão do campo prato, selecionar o prato PÃO DE QUEIJO, inserir a quantidade, clicar em 'salvar e próximo'
    //verificar a mensagem exibida na tela informando que é impossível adicionar, pois o registro já existe
    //clicar no botão ok, clicar em cancelar, clicar em voltar
    @Test
    public void teste06() {
        relacaoPratoXEmbalagemPage = new RelacaoPratoXEmbalagemPage();
        relacaoPratoXEmbalagemFlows = new RelacaoPratoXEmbalagemFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        relacaoPratoXEmbalagemFlows.navegateTelaPratoXEmbalagem();
        relacaoPratoXEmbalagemPage.registroJaExisteAddEmbalagem();
        relacaoPratoXEmbalagemPage.registroJaExisteAddPrato();
    }


}
