package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.SetorDaCozinhaFlows;
import org.testng.Assert;
import org.testng.annotations.Test;

public class SetorDaCozinhaTests extends TestBase {

SetorDaCozinhaFlows setorDaCozinhaFlows;
LoginFlows loginFlows;


public void acessarTela(){
    String NMTELA = "Setor da Cozinha";
    loginFlows = new LoginFlows();
    setorDaCozinhaFlows = new SetorDaCozinhaFlows();
    loginFlows.efetuarLogin();
    setorDaCozinhaFlows.acessarTela();
    Assert.assertEquals(NMTELA,setorDaCozinhaFlows.confirmaTela(), "Validando se a tela acessada está correta");

}


@Test
public void cadastraSetor(){
    String UNIDADE = "0002";
    String CDSETOR01 = "01";
    String NMSETOR01 = "AÇOUGUE";
    String CDSETOR02 = "02";
    String NMSETOR02 = "FRIOS";
    String MSESPERADA = "AÇOUGUE";
    String MSGESPERADA = "FRIOS";
    String MSGESPERADAINSERCAO = "Impossível adicionar. Registro já existe.";
    acessarTela();
    setorDaCozinhaFlows.buscaUnidade(UNIDADE);
    setorDaCozinhaFlows.insereSetor(CDSETOR01,NMSETOR01);
    setorDaCozinhaFlows.insereSetor(CDSETOR02,NMSETOR02);
    Assert.assertEquals(setorDaCozinhaFlows.validaCadastro(),MSESPERADA,"Falha ao cadastrar o setor 01: ");
    Assert.assertEquals(setorDaCozinhaFlows.validaCadastro02(),MSGESPERADA,"Falha ao cadastrar o setor 02: ");
    setorDaCozinhaFlows.validaInsercaoRegistroExistente(CDSETOR01,NMSETOR01);
    Assert.assertEquals(setorDaCozinhaFlows.mensagemEncontrada(),MSGESPERADAINSERCAO,"Validação com falha!!");
}

@Test
public void editarSetor(){
    String UNIDADE = "0004";
    String NMSETOR01 = "JANTAR";
    String NMSETOR02 = "SALADA";
    String MSGESPERADA01 = "JANTAR";
    String MSGESPERADA02 = "SALADA";
    acessarTela();
    setorDaCozinhaFlows.buscaUnidade(UNIDADE);
    setorDaCozinhaFlows.editarSetor(NMSETOR01,NMSETOR02);
    Assert.assertEquals(setorDaCozinhaFlows.validarEdicao01(),MSGESPERADA01,"A edição do setor 01 não foi salva corretamente: ");
    Assert.assertEquals(setorDaCozinhaFlows.validarEdicao02(),MSGESPERADA02,"A edição do setor 02 não foi salva corretamente: ");
}

@Test
public void excluirSetor() {
    String UNIDADE = "0002";
    String MSESPERADA = "Não há registros";
    acessarTela();
    setorDaCozinhaFlows.buscaUnidade(UNIDADE);
    setorDaCozinhaFlows.excluirSetorCozinha();
    Assert.assertEquals(setorDaCozinhaFlows.validaExclusaoSetor(),MSESPERADA,"Exclusão não realizada: ");
    setorDaCozinhaFlows.excluirRegistroRelacionado();
}

}
